<?php

if (!defined('ABSPATH')) {
	exit();
}

if (!class_exists('Addify_Gpby_Meta_Box')) :

	class Addify_Gpby_Meta_Box {
		public function __construct() {
			$this->adf_gpby_meta_box_fun();
		}

		private function adf_gpby_meta_box_fun() {
			$this->include_files();
			add_action('add_meta_boxes', array( $this, 'addify_gpby_add_meta_box' ));
			add_action('save_post_addify_gpby', array( $this, 'addify_save_gpby_meta_box_data' ));
			add_action('save_post_addify_gpinfo', array( $this, 'addify_save_gpif_meta_box_data' ));
			add_action('admin_enqueue_scripts', array( $this, 'adf_gpby_enqueue_scripts' )); 
		}

		public function include_files() {
			include_once AF_GPBY_DIR . 'includes/admin/addify-gpby-product-tab.php';
			include_once AF_GPBY_DIR . 'includes/admin/addify-gpby-setting.php';
			include_once AF_GPBY_DIR . 'includes/admin/addify-gpby-add-column.php';
		}

		public function adf_gpby_enqueue_scripts() {
			global $wp_roles, $post_type, $page;
			$getUserRole  = $wp_roles;
			$current_page = null;
			$current_page = filter_input(INPUT_GET, 'page', FILTER_SANITIZE_FULL_SPECIAL_CHARS);
			
			if ('addify_gpby' == $post_type || 'addify_gpinfo' == $post_type || 'product' == $post_type || 'group-settings' == $current_page) :
				wp_enqueue_style( 'wp-color-picker' );
				wp_enqueue_style('adf_gpby_admin', AF_GPBY_URL . '/assets/css/admin.css', false, '1.1');
				wp_enqueue_script('adf_gpby_js_call', AF_GPBY_URL . 'assets/js/admin.js', array( 'wp-color-picker', 'jquery' ), '1.0.2', false);

				//select2 css and js
				wp_enqueue_script('jquery');
				wp_enqueue_script( 'select2-js', plugins_url('assets/js/select2/select2.min.js', WC_PLUGIN_FILE), array( 'jquery' ), '4.0.3', true );
				wp_enqueue_style( 'select2-css', plugins_url('assets/css/select2.css', WC_PLUGIN_FILE), array(), '5.7.2' );
					
				$wsp_data = array(
					'admin_base_url' => admin_url(),
					'admin_url'      => admin_url('admin-ajax.php'),
					'nonce'          => wp_create_nonce('addify_gpby_meta_box'),
					'userRole'       => $getUserRole,
					'sampleImag'     => AF_GPBY_URL . 'assets/upload/sample.jpg',
					'post_type'      => get_post_type(),
				);
				wp_localize_script( 'adf_gpby_js_call', 'wsp_php_vars', $wsp_data );
			endif;
		}

		public function addify_gpby_add_meta_box() {
			add_meta_box(
				'addify_gpby_meta_box',
				'Rule Details',
				array( $this, 'addify_gpby_meta_box_callback' ),
				'addify_gpby',
				'normal',
				'default'
			);

			add_meta_box(
				'addify_gpinfo_meta_box',
				'Group Info Details',
				array( $this, 'addify_gpinfo_meta_box_callback' ),
				'addify_gpinfo',
				'normal',
				'default'
			);
		}

		public function addify_gpby_meta_box_callback( $post ) {
			wp_nonce_field('addify_gpby_meta_box', 'addify_gpby_meta_box_nonce');

			$adf_gpby_allow_public_gp        = get_post_meta($post->ID, 'adf_gpby_allow_public_gp', true); 
			$postAllProdCheck                = get_post_meta($post->ID, 'adf_gpby_prod_check', true);                  
			$gpby_applied_products           =  (array) get_post_meta( $post->ID, 'gpby_applied_products', true );
			$gpby_applied_categories         =  (array) get_post_meta( $post->ID, 'gpby_applied_categories', true ); 
			$gpby_applied_user_roles         =  (array) get_post_meta( $post->ID, 'gpby_applied_user_roles', true );  
			$adf_gpby_no_group               =  get_post_meta( $post->ID, 'adf_gpby_no_group', true );  
			$adf_gpby_private_no_group       =  get_post_meta( $post->ID, 'adf_gpby_private_no_group', true );  
			$adf_gpby_total_group_member     = get_post_meta($post->ID, 'adf_gpby_total_group_member', true); 
			$adf_gpby_group_act_no_days      = get_post_meta($post->ID, 'adf_gpby_group_act_no_days', true); 
			$adf_gpby_sin_cus_enb            = get_post_meta($post->ID, 'adf_gpby_sin_cus_enb', true); 
			$adf_gpby_all_priv_grp           = get_post_meta($post->ID, 'adf_gpby_all_priv_grp', true);
			$adf_gpby_strt_date              =  get_post_meta( $post->ID, 'adf_gpby_strt_date', true ); 
			$adf_gpby_end_date               =  get_post_meta( $post->ID, 'adf_gpby_end_date', true ); 
			$adf_gpby_gp_desc                =  get_post_meta( $post->ID, 'adf_gpby_gp_desc', true ); 
			$adf_gpby_disc_type              = get_post_meta($post->ID, 'adf_gpby_disc_type', true); 
			$adf_gpby_price_type             = get_post_meta($post->ID, 'adf_gpby_price_type', true); 
			$adf_gpby_group_discount_value   = get_post_meta($post->ID, 'adf_gpby_group_discount_value', true);
			$adf_gpby_group_discount_line    = get_post_meta($post->ID, 'adf_gpby_group_discount_line', true);
			$adf_discount_groupd_description = get_post_meta($post->ID, 'adf_discount_groupd_description', true);
			
			$gateways = $this->get_payment_gateways();
			global $wp_roles;
			$order_statuses = wc_get_order_statuses();
			?>
			<div class="addify-gpby-meta-box">
			<div id="adf-gpby-error-check">
				<?php echo esc_html__('Please select at least one option: Private Group or Public Group.', 'addify-group-buy-for-woocommerce'); ?>
			</div>
			<?php

				woocommerce_wp_checkbox( array( 
					'id'          => 'adf_gpby_allow_public_gp', 
					'label'       => esc_html__('Public Group', 'addify-group-buy-for-woocommerce'), 
					'description' => esc_html__('Enable to allow public group creation (any registered user can join)', 'addify-group-buy-for-woocommerce'),
					'value'       => 'true',
					'cbvalue'     => ( 'true' === $adf_gpby_allow_public_gp ) ? 'true' : '',
					'class'       => 'group-checkbox',
				) ); 

				woocommerce_wp_text_input(array(
					'id'                => 'adf_gpby_no_group',
					'label'             => esc_html__('Allow Number of Public Group', 'addify-group-buy-for-woocommerce'),
					'type'              => 'number',
					'desc_tip'          => 'true',
					'style'             => 'width:60%',
					'description'       => esc_html__('Add the number of public groups that can be created on a single product', 'addify-group-buy-for-woocommerce'),
					'value'             => ( isset($adf_gpby_no_group) && !empty($adf_gpby_no_group) ? $adf_gpby_no_group : 1 ),
					'custom_attributes' => array(
						'min' => '1',
					),
				));
			?>
				<div class="adf_gpby_no_group_field adf-gpby-user-rol-text"> <?php echo esc_html__('Add the number of public groups that can be created on a single product.', 'addify-group-buy-for-woocommerce'); ?></div>
				<?php

				woocommerce_wp_checkbox( array( 
					'id'          => 'adf_gpby_all_priv_grp', 
					'label'       => esc_html__('Private Group', 'addify-group-buy-for-woocommerce'), 
					'description' => esc_html__('Enable to allow private group creation (any registered user can join)', 'addify-group-buy-for-woocommerce'),
					'value'       => 'true',
					'cbvalue'     => ( 'true' === $adf_gpby_all_priv_grp ) ? 'true' : '',
					'class'       => 'group-checkbox',
				) );

				woocommerce_wp_text_input(array(
					'id'                => 'adf_gpby_private_no_group',
					'label'             => esc_html__('Allow Number of Private Group', 'addify-group-buy-for-woocommerce'),
					'type'              => 'number',
					'desc_tip'          => 'true',
					'style'             => 'width:60%',
					'description'       => esc_html__('Enter the number of groups allowed.', 'addify-group-buy-for-woocommerce'),
					'value'             => ( isset($adf_gpby_private_no_group) && !empty($adf_gpby_private_no_group) ? $adf_gpby_private_no_group : 1 ),
					'custom_attributes' => array(
						'min' => '1',
					),
				));
				?>
				<div class="adf_gpby_private_no_group_field adf-gpby-user-rol-text"> <?php echo esc_html__('Add the number of private groups that can be created on a single product.', 'addify-group-buy-for-woocommerce'); ?></div>
				<?php

				woocommerce_wp_text_input(array(
					'id'                => 'adf_gpby_total_group_member',
					'label'             => esc_html__('Group Member', 'addify-group-buy-for-woocommerce'),
					'type'              => 'number',
					'desc_tip'          => 'true',
					'style'             => 'width:60%',
					'description'       => esc_html__('Enter the Maximum number of Member.', 'addify-group-buy-for-woocommerce'),
					'value'             => ( isset($adf_gpby_total_group_member) && !empty($adf_gpby_total_group_member) ? $adf_gpby_total_group_member : 1 ),
					'custom_attributes' => array(
						'min' => '1',
					),
				));
				?>
				<div class="adf-gpby-user-rol-text"> <?php echo esc_html__('Add the number of members required to complete a group.', 'addify-group-buy-for-woocommerce'); ?></div>
				<?php
				woocommerce_wp_text_input(array(
					'id'                => 'adf_gpby_group_act_no_days',
					'label'             => esc_html__('Days', 'addify-group-buy-for-woocommerce'),
					'type'              => 'number',
					'desc_tip'          => 'true',
					'style'             => 'width:60%',
					'description'       => esc_html__('Enter the number of days to rule apply.', 'addify-group-buy-for-woocommerce'),
					'value'             => ( isset($adf_gpby_group_act_no_days) && !empty($adf_gpby_group_act_no_days) ? $adf_gpby_group_act_no_days : 1 ),
					'custom_attributes' => array(
						'min' => '1',
					),
				));
				?>
				<div id="adf-label-user-role-desc" class="adf-gpby-user-rol-text"> <?php echo esc_html__('Add number of days within which members are required to complete the group in order to get a discount.', 'addify-group-buy-for-woocommerce'); ?></div>
				<?php
				woocommerce_wp_checkbox( array( 
					'id'          => 'adf_gpby_prod_check', 
					'label'       => esc_html__('All Products', 'addify-group-buy-for-woocommerce'), 
					'description' => 'Check to enable group buying on all products and categories',
					'value'       => 'true',
					'cbvalue'     => ( 'true' === $postAllProdCheck ) ? 'true' : '',
				) ); 
				
			 
				foreach ( $gpby_applied_products as $product_id ) {
					$productArr[ $product_id ] =  get_the_title($product_id) ;

				}
				?>
				<div class="adf-bmsm-select-prod">
				<?php
				woocommerce_wp_select(array(
					'id'                => 'gpby_applied_products[]',
					'label'             => esc_html__('Select Products', 'addify-group-buy-for-woocommerce'),
					'class'             => 'adf-gpby-live-search-for',
					'options'           => $productArr,
					'value'             => $gpby_applied_products,
					'style'             => 'width:60%',
					'custom_attributes' => array(
						'multiple'         => 'multiple',
						'data-search_type' => 'products',
					),
				));
				?>
				<div class="adf-gpby-user-rol-text"> <?php echo esc_html__('Choose products to enable group buying on specific products.', 'addify-group-buy-for-woocommerce'); ?></div>
				</div>
				<div class="adf-bmsm-select-cat">
				<?php
				$categories = get_terms(array(
					'taxonomy'   => 'product_cat',
					'hide_empty' => false,
				));

				woocommerce_wp_select(array(
					'id'                => 'gpby_applied_categories[]',
					'label'             => esc_html__('Select Categories', 'addify-group-buy-for-woocommerce'),
					'class'             => 'adf-gpby-live-search-for',
					'options'           => wp_list_pluck($categories, 'name', 'term_id'),
					'value'             => $gpby_applied_categories,
					'style'             => 'width:60%',
					'custom_attributes' => array(
						'multiple'         => 'multiple',
						'data-search_type' => 'categories',
					),
				));
				?>
				<div class="adf-gpby-user-rol-text"> <?php echo esc_html__('Choose categories to enable group buying on specific categories.', 'addify-group-buy-for-woocommerce'); ?></div>
				</div>
				<?php

				woocommerce_wp_select(array(
					'id'                => 'gpby_applied_user_roles[]',
					'label'             => esc_html__('Apply to User Roles', 'addify-group-buy-for-woocommerce'),
					'class'             => 'adf-gpby-live-search-for',
					'options'           => $wp_roles->get_names(),
					'value'             => $gpby_applied_user_roles,
					'style'             => 'width:60%',
					'custom_attributes' => array(
						'multiple'         => 'multiple',
						'data-search_type' => 'userroles',
					),
				));
				?>
				<div class="adf-gpby-user-rol-text"> <?php echo esc_html__('Select to offer group buying to specific user roles (leave empty to apply on all).', 'addify-group-buy-for-woocommerce'); ?></div>
				<?php
				woocommerce_wp_checkbox( array( 
					'id'          => 'adf_gpby_sin_cus_enb', 
					'label'       => esc_html__('Single Customer', 'addify-group-buy-for-woocommerce'), 
					'description' => esc_html__('Check to restrict a user to buy multiple times in a group.', 'addify-group-buy-for-woocommerce'),
					'value'       => 'true',
					'cbvalue'     => ( 'true' === $adf_gpby_sin_cus_enb ) ? 'true' : '',
				) ); 

				woocommerce_wp_select(array(
					'id'      => 'adf_gpby_price_type',
					'label'   => esc_html__('Select Price Type', 'addify-group-buy-for-woocommerce'),
					// 'description' => esc_html__('Choose whether to apply group buying discount on regular or sale prices.', 'addify-group-buy-for-woocommerce'),
					'options' => array(
						'regprice' => esc_html__('Regular Price', 'addify-group-buy-for-woocommerce'),
						'salprice' => esc_html__('Sales Price', 'addify-group-buy-for-woocommerce'),
					),
					'value'   => $adf_gpby_price_type, 
				));
				?>
				<div class="adf-gpby-user-rol-text"> <?php echo esc_html__('Choose whether to apply group buying discount on regular or sale prices.', 'addify-group-buy-for-woocommerce'); ?></div> 
				<?php

				woocommerce_wp_select(array(
					'id'                => 'adf_gpby_disc_type',
					'label'             => esc_html__('Select Discount Type', 'addify-group-buy-for-woocommerce'),
					// 'description' => esc_html__('Choose whether to offer group purchase discount in percentage or amount.', 'addify-group-buy-for-woocommerce'),
					'options'           => array(
						'percent' => esc_html__('Percentage', 'addify-group-buy-for-woocommerce'),
						'fixed'   => esc_html__('Fixed', 'addify-group-buy-for-woocommerce'),
					),
					'value'             => $adf_gpby_disc_type, 
					'custom_attributes' => array(
						'style' => 'width:10%',
					),
				));
				?>
				<div class="adf-gpby-user-rol-text"> <?php echo esc_html__('Choose whether to offer group purchase discount in percentage or amount.', 'addify-group-buy-for-woocommerce'); ?></div> 
				<?php

				woocommerce_wp_text_input(array(
					'id'                => 'adf_gpby_group_discount_value',
					'label'             => esc_html__('Discount Value', 'addify-group-buy-for-woocommerce'),
					'type'              => 'number',
					'desc_tip'          => 'true',
					'style'             => 'width:10%',
					'description'       => esc_html__('Enter the value of discount.', 'addify-group-buy-for-woocommerce'),
					'value'             => ( isset($adf_gpby_group_discount_value) && !empty($adf_gpby_group_discount_value) ? $adf_gpby_group_discount_value : 0 ),
					'custom_attributes' => array(
						'min' => '1',
					),
				));

				woocommerce_wp_text_input(array(
					'id'          => 'adf_gpby_group_discount_line',
					'label'       => esc_html__('Group Discount Custom Text', 'addify-group-buy-for-woocommerce'),
					'type'        => 'text',
					'desc_tip'    => true,
					'style'       => 'width:60%',
					'description' => esc_html__('Enter the discount percentage for the group.', 'addify-group-buy-for-woocommerce'),
					'value'       => ( isset($adf_gpby_group_discount_line) && !empty($adf_gpby_group_discount_line) ? $adf_gpby_group_discount_line : 'Join this group and claim {discount_value}% discount.' ),
				));
				?>
				<div id="adf-lbl-custom-txt-desc" class="adf-gpby-user-rol-text"> <?php echo esc_html__('Add custom text that will be displayed in front of group title (You can use variables such as {discount_value} for your messages)', 'addify-group-buy-for-woocommerce'); ?></div>

				<div id="adf-lbl-custom-txt-desc-2">
					
					<label class="addify-gpby-meta-box" style="padding: 0px; margin-top: 47px;"><?php echo esc_html__('Group Description', 'addify-group-buy-for-woocommerce'); ?></label>

					<span style="width: 60%">
						<?php
						$content = ( isset($adf_discount_groupd_description) && !empty($adf_discount_groupd_description) )? $adf_discount_groupd_description : '';
						wp_editor($content, 'adf_gpby_term_condition_desc', array( 
							'textarea_name' => 'adf_discount_groupd_description',
							'media_buttons' => false,
							'textarea_rows' => 10,
						));
						?>
					</span>
				</div>

				<?php
				woocommerce_wp_text_input(array(
					'id'                => 'adf_gpby_strt_date',
					'label'             => esc_html__('Starting Date', 'addify-group-buy-for-woocommerce'),
					// 'description' => esc_html__('Choose starting date on which group purchases will be enabled on the product(s)', 'addify-group-buy-for-woocommerce'),
					'type'              => 'date',
					'value'             => $adf_gpby_strt_date,
					'custom_attributes' => array(
						'required' => 'required',
					),
				));
				?>
				<div class="adf-gpby-user-rol-text"> <?php echo esc_html__('Choose starting date on which group purchases will be enabled on the product(s).', 'addify-group-buy-for-woocommerce'); ?></div> 
				<?php

				woocommerce_wp_text_input(array(
					'id'                => 'adf_gpby_end_date',
					'label'             => esc_html__('Ending Date', 'addify-group-buy-for-woocommerce'),
					// 'description' => esc_html__('Choose ending date on which group purchases will be disabled on the product(s)', 'addify-group-buy-for-woocommerce'),
					'type'              => 'date',
					'value'             => $adf_gpby_end_date,
					'custom_attributes' => array(
						'required' => 'required',
					),
				));
				?>
				<div class="adf-gpby-user-rol-text"> <?php echo esc_html__('Choose ending date on which group purchases will be disabled on the product(s).', 'addify-group-buy-for-woocommerce'); ?></div> 			</div>
			<?php  
		}

		public function addify_gpinfo_meta_box_callback( $post ) {

			wp_nonce_field('addify_gpinfo_meta_box', 'addify_gpinfo_meta_box_nonce');
			$countMemeber = 0;
			$custom_label = get_post_meta($post->ID, 'adf_pgif_custom_label', true);

			$groupId                    = get_post_meta($post->ID, 'adf_pgif_group_id', true);
			$groupName                  = get_post_meta($post->ID, 'adf_pgif_group_name', true);
			$groupType                  = get_post_meta($post->ID, 'adf_pgif_group_type', true);
			$groupPrice                 = get_post_meta($post->ID, 'adf_pgif_group_price', true);
			$groupAuth                  = get_post_meta($post->ID, 'adf_pgif_group_auth', true);
			$createdDate                = get_post_meta($post->ID, 'adf_pgif_group_created', true);
			$groupExpire                = get_post_meta($post->ID, 'adf_pgif_group_exprire', true);
			$groupSize                  = intval(get_post_meta($post->ID, 'adf_gpif_group_member', true));
			$productName                = get_post_meta($post->ID, 'adf_pgif_product_name', true);
			$productId                  = get_post_meta($post->ID, 'adf_pgif_product_id', true); 
			$adf_gpby_group_info_status = get_post_meta($post->ID, 'adf_gpby_group_info_status', true);
			$groupInfoData              = get_post_meta($post->ID, 'adf_pgif_join_group_member_info', true);
			$countMemeber               = intval(get_post_meta($post->ID, 'adf_pgif_group_join_memeber', true));
			$enableRefund               = get_post_meta($post->ID, 'adf_gpif_enable_refund', true);
			


			$prodcut_link = $this->get_product_edit_link_by_id($productId);

			?>
			<div class="adf-gpby-gorup_info_mian_container">
				<div class="adf-gpby-group-info-sub-conatainer">
					<div class="adf-gpby-group-info-sub-head">
						<span><?php echo esc_html__('Group', 'addify-group-buy-for-woocommerce'); ?></span>
					</div>
					<hr>
					<div class = "adf-gpby-info_left_side">
						<div>
							<div class="adf-gpby-group-line">
								<label><?php echo esc_html__('Group ID', 'addify-group-buy-for-woocommerce'); ?></label>
							</div>
							<div class="adf-gpby-group-line">
								<label><?php echo esc_html__('Group Name', 'addify-group-buy-for-woocommerce'); ?></label>
							</div>
							<div class="adf-gpby-group-line">
								<label><?php echo esc_html__('Group Type', 'addify-group-buy-for-woocommerce'); ?></label>
							</div>
							<div class="adf-gpby-group-line">
								<label><?php echo esc_html__('Discount Price', 'addify-group-buy-for-woocommerce'); ?></label>
							</div>
							<div class="adf-gpby-group-line">
								<label><?php echo esc_html__('Group Author', 'addify-group-buy-for-woocommerce'); ?></label>
							</div>
							<div class="adf-gpby-group-line">
								<label><?php echo esc_html__('Created Date', 'addify-group-buy-for-woocommerce'); ?></label>
							</div>
						</div>
						<div>
							<div class="adf-gpby-group-line"><?php echo esc_html($groupId); ?></div>
							<div class="adf-gpby-group-line"><?php echo esc_html($groupName); ?></div>
							<div class="adf-gpby-group-line"><?php echo esc_html($groupType); ?></div>
							<div class="adf-gpby-group-line"><?php echo esc_html($groupPrice); ?></div>
							<div class="adf-gpby-group-line"><?php echo esc_html($groupAuth); ?></div>
							<div class="adf-gpby-group-line"><?php echo esc_html($createdDate); ?></div>
						</div>
					</div>
				</div>         

				<div class="adf-gpby-group-info-sub-conatainer">
					<div class="adf-gpby-group-info-sub-head">
						<span><?php echo esc_html__('Group meta data', 'addify-group-buy-for-woocommerce'); ?></span>
					</div>
					<hr>

					<div class = "adf-gpby-info_left_side">
						<div>
							<div class="adf-gpby-group-line">
								<label><?php echo esc_html__('Expire Date', 'addify-group-buy-for-woocommerce'); ?></label>
							</div>

							<div class="adf-gpby-group-line">
								<label><?php echo esc_html__('Product Name', 'addify-group-buy-for-woocommerce'); ?></label>
							</div>

							<div class="adf-gpby-group-line">
								<label><?php echo esc_html__('Group Size', 'addify-group-buy-for-woocommerce'); ?></label>
							</div> 

							<div class="adf-gpby-group-line">
								<label><?php echo esc_html__('Join Member', 'addify-group-buy-for-woocommerce'); ?></label>
							</div> 

							<div class="adf-gpby-group-line">
								<label><?php echo esc_html__('Group Status', 'addify-group-buy-for-woocommerce'); ?></label>
							</div> 
						</div>
						<div>
							<div class="adf-gpby-group-line"><?php echo esc_html($groupExpire); ?></div>
							<div class="adf-gpby-group-line"> <a href = "<?php echo esc_html($prodcut_link); ?>"><?php echo esc_html($productName); ?></a></div>
							<div class="adf-gpby-group-line"><?php echo esc_html($groupSize); ?></div>
							<div class="adf-gpby-group-line">
								<?php echo esc_html($countMemeber) . esc_html(' (' . ( $groupSize - $countMemeber ) . esc_html__(' Remaining member)', 'addify-group-buy-for-woocommerce')); ?>
							</div>
							
							<select id="adf_gpby_group_info_status" name="adf_gpby_group_info_status" 
							<?php
							if ('qualified' == $adf_gpby_group_info_status || 'disqualified' == $adf_gpby_group_info_status) {
echo 'disabled';
							}
							?>
							>
								<option value="processing" <?php echo selected($adf_gpby_group_info_status, 'processing'); ?>><?php echo esc_html__('Processing', 'addify-group-buy-for-woocommerce'); ?></option>
								<option value="qualified" <?php echo selected($adf_gpby_group_info_status, 'qualified'); ?>><?php echo esc_html__('Qualified', 'addify-group-buy-for-woocommerce'); ?></option>
								<option value="disqualified" <?php echo selected($adf_gpby_group_info_status, 'disqualified'); ?>><?php echo esc_html__('Disqualified', 'addify-group-buy-for-woocommerce'); ?></option>
							</select>
						</div>
					</div>
				</div>
			</div>
			<div>
				<h1><?php echo esc_html__('Group Members', 'addify-group-buy-for-woocommerce'); ?></h1>

				<table class="adf-gpby-group_member_tb">
				<tr>
					<th><?php echo esc_html__('User Id', 'addify-group-buy-for-woocommerce'); ?></th>
					<th><?php echo esc_html__('Customer Name', 'addify-group-buy-for-woocommerce'); ?></th>
					<th><?php echo esc_html__('Start Date', 'addify-group-buy-for-woocommerce'); ?></th>
					<th><?php echo esc_html__('Order Id', 'addify-group-buy-for-woocommerce'); ?></th>
				</tr>
				<?php
				if (is_array($groupInfoData)) :
					foreach ($groupInfoData as $data) :
					
						$orderObj        = wc_get_order( $data[3] );
						$order_edit_link = $orderObj->get_edit_order_url();
					
						$user_edit_link = $this->get_user_edit_link_by_id($data[4]);
						?>
					<tr>
					<td> <a href=<?php echo esc_attr($user_edit_link); ?>> <?php echo esc_html('#' . $data[4]); ?></a></td>
						<td><?php echo esc_html($data[1]); ?></td>
						<td><?php echo esc_html($data[0]); ?></td>
						<td> <a href=<?php echo esc_attr($order_edit_link); ?>> <?php echo esc_html('#' . $data[3]); ?></a></td>
					</tr>
					<?php
					endforeach;
				endif;
				?>
				</table>
			</div>
			<?php
		}

		public function addify_save_gpby_meta_box_data( $post_id ) {
			
			if (!isset($_POST['addify_gpby_meta_box_nonce'])) {
				return;
			}

			if (isset($_POST['addify_gpby_meta_box_nonce'])) :
				if (!wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['addify_gpby_meta_box_nonce'])), 'addify_gpby_meta_box')) {
					return;
				}
			endif;

			if (isset($_POST['post_type']) && 'addify_gpby' == $_POST['post_type']) {
				if (!current_user_can('edit_post', $post_id)) {
					return;
				}
			}

			$post_check_all_prod = isset($_POST['adf_gpby_prod_check']) ? 'true' : '';
			update_post_meta($post_id, 'adf_gpby_prod_check', $post_check_all_prod);

			//Save allow public group
			$adf_gpby_allow_public_gp = isset($_POST['adf_gpby_allow_public_gp']) ? 'true' : '';
			update_post_meta($post_id, 'adf_gpby_allow_public_gp', $adf_gpby_allow_public_gp);

			//Save applied Products
			if ( isset( $_POST['gpby_applied_products'] ) ) {
				update_post_meta( $post_id, 'gpby_applied_products', sanitize_meta('', wp_unslash($_POST['gpby_applied_products']), '' ) );
			} else {
				delete_post_meta( $post_id, 'gpby_applied_products' );
			}

			//Save applied Categories
			if ( isset( $_POST['gpby_applied_categories'] ) ) {
				update_post_meta( $post_id, 'gpby_applied_categories', sanitize_meta('', wp_unslash($_POST['gpby_applied_categories']), '' ) );
			} else {
				delete_post_meta( $post_id, 'gpby_applied_categories' );
			}

			//Save applied User roles
			if ( isset( $_POST['gpby_applied_user_roles'] ) ) {
				update_post_meta( $post_id, 'gpby_applied_user_roles', sanitize_meta('', wp_unslash($_POST['gpby_applied_user_roles']), '' ) );
			} else {
				delete_post_meta( $post_id, 'gpby_applied_user_roles' );
			}

			//Save no of private group
			if ( isset( $_POST['adf_gpby_private_no_group'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_private_no_group', sanitize_text_field(wp_unslash($_POST['adf_gpby_private_no_group'])));
			}

			//Save no of public group
			if ( isset( $_POST['adf_gpby_no_group'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_no_group', sanitize_text_field(wp_unslash($_POST['adf_gpby_no_group'])));
			} 

			//Save total number of memeber
			if ( isset( $_POST['adf_gpby_total_group_member'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_total_group_member', sanitize_text_field(wp_unslash($_POST['adf_gpby_total_group_member'])));
			} 

			//Save active number of days
			if ( isset( $_POST['adf_gpby_group_act_no_days'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_group_act_no_days', sanitize_text_field(wp_unslash($_POST['adf_gpby_group_act_no_days'])));
			}

			//save enable allow single customer
			$adf_gpby_sin_cus_enb = isset($_POST['adf_gpby_sin_cus_enb']) ? 'true' : '';
			update_post_meta($post_id, 'adf_gpby_sin_cus_enb', $adf_gpby_sin_cus_enb);

			//save enable allow private group
			$adf_gpby_all_priv_grp = isset($_POST['adf_gpby_all_priv_grp']) ? 'true' : '';
			update_post_meta($post_id, 'adf_gpby_all_priv_grp', $adf_gpby_all_priv_grp);

			//save discount value
			if ( isset( $_POST['adf_gpby_group_act_no_days'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_group_act_no_days', sanitize_text_field(wp_unslash($_POST['adf_gpby_group_act_no_days'])));
			}

			//save discount text line
			if ( isset( $_POST['adf_gpby_group_discount_line'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_group_discount_line', sanitize_text_field(wp_unslash($_POST['adf_gpby_group_discount_line'])));
			}

			if ( isset( $_POST['adf_discount_groupd_description'] )) {
				update_post_meta( $post_id, 'adf_discount_groupd_description', sanitize_meta('', wp_unslash($_POST['adf_discount_groupd_description']), ''));
			}

			//save start date
			if ( isset( $_POST['adf_gpby_strt_date'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_strt_date', sanitize_text_field(wp_unslash($_POST['adf_gpby_strt_date'])));
			} 

			//save end date
			if ( isset( $_POST['adf_gpby_end_date'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_end_date', sanitize_text_field(wp_unslash($_POST['adf_gpby_end_date'])));
			} 

			// save gruop description
			if ( isset( $_POST['adf_gpby_gp_desc'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_gp_desc', sanitize_text_field(wp_unslash($_POST['adf_gpby_gp_desc'])));
			} 
			
			// save pextentage type
			$adf_gpby_disc_type = isset($_POST['adf_gpby_disc_type']) ? sanitize_text_field(wp_unslash($_POST['adf_gpby_disc_type'])) : '';
			update_post_meta($post_id, 'adf_gpby_disc_type', $adf_gpby_disc_type);

			// save price type
			$adf_gpby_price_type = isset($_POST['adf_gpby_price_type']) ? sanitize_text_field(wp_unslash($_POST['adf_gpby_price_type'])) : '';
			update_post_meta($post_id, 'adf_gpby_price_type', $adf_gpby_price_type);

			//save discount value
			if ( isset( $_POST['adf_gpby_group_discount_value'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_group_discount_value', sanitize_text_field(wp_unslash($_POST['adf_gpby_group_discount_value'])));
			}
			//save data from custom post group info type
		}

		public function addify_save_gpif_meta_box_data( $post_id ) {

			if (!isset($_POST['addify_gpinfo_meta_box_nonce'])) {
				return;
			}

			if (isset($_POST['addify_gpinfo_meta_box_nonce'])) :
				if (!wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['addify_gpinfo_meta_box_nonce'])), 'addify_gpinfo_meta_box')) {
					return;
				}
			endif;

			if (isset($_POST['post_type']) && 'addify_gpinfo' == $_POST['post_type'] ) {
				if (!current_user_can('edit_post', $post_id)) {
					return;
				}
			}

			if ( isset( $_POST['adf_gpby_group_info_status'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_group_info_status', sanitize_text_field(wp_unslash($_POST['adf_gpby_group_info_status'])));

				if ('qualified' == $_POST['adf_gpby_group_info_status']) :
					$emails         = array();
					$groupName      = get_post_meta($post_id, 'adf_pgif_group_name', true);
					$groupInfoDatas = get_post_meta($post_id, 'adf_pgif_join_group_member_info', true);

					if (is_array($groupInfoDatas)) :
						foreach ($groupInfoDatas as $groupInfoData) :
								$email[]          = $this->getEmailById($groupInfoData[4]);
								$productPermalink = $this->getProductParmlink($groupInfoData[6]);
						endforeach;
					endif;

					array_push($emails, get_option('admin_email'));
					if ($email) :
						$this->sendEmail($email, $productPermalink, $groupName);
					endif;
					
				endif;


				if ('disqualified' == $_POST['adf_gpby_group_info_status']) :
					$emails         = array();
					$groupName      = get_post_meta($post_id, 'adf_pgif_group_name', true);
					$groupInfoDatas = get_post_meta($post_id, 'adf_pgif_join_group_member_info', true);

					if (is_array($groupInfoDatas)) :
						foreach ($groupInfoDatas as $groupInfoData) :
								$email[]          = $this->getEmailById($groupInfoData[4]);
								$productPermalink = $this->getProductParmlink($groupInfoData[6]);
						endforeach;
					endif;

					array_push($emails, get_option('admin_email'));
					if ($email) :
						$this->sendDisqualifyEmail($email, $productPermalink, $groupName);
					endif;
				endif;

			}
		}

		public function get_payment_gateways() {
			$payment_gateways = WC()->payment_gateways->get_available_payment_gateways();
			$gateways         = array();
	
			foreach ( $payment_gateways as $gateway_id => $gateway ) {
				$gateways[ $gateway_id ] =  $gateway->get_title() ;
			}
			
			return $gateways;
		}

		public function get_product_edit_link_by_id( $product_id ) {
			if (is_numeric($product_id)) {
				$edit_link = get_edit_post_link($product_id);
				return $edit_link;
			} else {
				return false;
			}
		}

		public function get_order_edit_link_by_id( $order_id ) {
	
			if (is_numeric($order_id)) {
			   
				$edit_link = get_edit_post_link($order_id);
				// Check if the post type is 'shop_order'
				$post = get_post($order_id);
				if ($post && 'shop_order' === $post->post_type) {
					return $edit_link;
				} else {
					return false;
				}
			} else {
				return false;
			}
		}

		public function get_user_edit_link_by_id( $user_id ) {
			if (is_numeric($user_id)) {
				$edit_link = admin_url('user-edit.php?user_id=' . intval($user_id));
				return $edit_link;
			} 
		}

		public function sendEmail( $emails, $productLinks, $groupName ) {

			$groupInfoDatas = get_post_meta($post_id, 'adf_pgif_join_group_member_info', true);
			foreach ($groupInfoDatas as $groupInfoData) :
				$email[]          = $this->getEmailById($groupInfoData[4]);
				$productPermalink = $this->getProductParmlink($groupInfoData[3]);
				break;
			endforeach;

			array_push($emails, get_option('admin_email'));
			
			$new_form_data = array(
				'product_url' => esc_url($productLinks),
				'group_title' => esc_html($groupName),
				'emails'      => $emails,
			);

			WC()->mailer()->emails['Adf_Gpby_Qualified_Group_Email']->trigger($new_form_data );
		}

		public function sendDisqualifyEmail( $emails, $productLinks, $groupName ) {

			array_push($emails, get_option('admin_email'));
	
			$new_form_data = array(
				'product_url' => esc_url($productLinks),
				'group_title' => esc_html($groupName),
				'emails'      => $emails,
			);

			WC()->mailer()->emails['Adf_Gpby_Disqualified_Group_Email']->trigger($new_form_data );
		}

		public function getEmailById( $id ) {
			$current_user_data = get_userdata($id);
			$user_email        = $current_user_data->user_email;
			return $user_email;
		}

		public function getProductParmlink( $id ) {
			$link = get_permalink( $id );
			return $link;
		}
	}

	new Addify_Gpby_Meta_Box();
endif;