<?php

if (!defined('ABSPATH')) {
	exit();
}

if (!class_exists('Addify_Gpby_Product_Tab')) {

	class Addify_Gpby_Product_Tab {

		public function __construct() {
			add_action('woocommerce_product_data_tabs', array( $this, 'adf_gpby_product_data_tab' ));
			add_action( 'woocommerce_product_data_panels', array( $this, 'adf_gpby_product_data_fields' ));
			add_action( 'woocommerce_process_product_meta_simple', array( $this, 'adf_gpby_product_tab_data' ));
		}

		public function adf_gpby_product_data_tab( $product_data_tabs ) {
			$product_data_tabs['adf-gpby-tab'] = array(
				'label'  => __( 'Group Buying', 'addify-group-buy-for-woocommerce' ),
				'class'  => array( 'addify_gpby_wsp_tab', 'show_if_simple' ),
				'target' => 'adf_gpby_product_data',
			);
			return $product_data_tabs;
		}

		public function adf_gpby_product_data_fields() {
			global $woocommerce, $post;
			wp_nonce_field('addify_gpby_meta_box', 'addify_gpby_meta_box_nonce');
			$adf_gpby_no_group               = get_post_meta($post->ID, 'adf_gpby_no_group', true); 
			$adf_gpby_show_form              = get_post_meta($post->ID, 'adf_gpby_show_form', true);
			$adf_gpby_allow_public_gp        = get_post_meta($post->ID, 'adf_gpby_allow_public_gp', true); 
			$adf_gpby_private_no_group       = get_post_meta($post->ID, 'adf_gpby_private_no_group', true); 
			$adf_gpby_total_group_member     = get_post_meta($post->ID, 'adf_gpby_total_group_member', true); 
			$adf_gpby_group_act_no_days      = get_post_meta($post->ID, 'adf_gpby_group_act_no_days', true); 
			$adf_gpby_sin_cus_enb            = get_post_meta($post->ID, 'adf_gpby_sin_cus_enb', true);
			$adf_gpby_all_priv_grp           = get_post_meta($post->ID, 'adf_gpby_all_priv_grp', true);
			$adf_gpby_strt_date              =  get_post_meta( $post->ID, 'adf_gpby_strt_date', true ); 
			$adf_gpby_end_date               =  get_post_meta( $post->ID, 'adf_gpby_end_date', true ); 
			$adf_gpby_disc_type              = get_post_meta($post->ID, 'adf_gpby_disc_type', true); 
			$adf_gpby_price_type             = get_post_meta($post->ID, 'adf_gpby_price_type', true); 
			$adf_gpby_discount_value         = get_post_meta($post->ID, 'adf_gpby_discount_value', true);
			$gpby_applied_user_roles         =  (array) get_post_meta( $post->ID, 'gpby_applied_user_roles', true );
			$adf_gpby_group_discount_line    = get_post_meta($post->ID, 'adf_gpby_group_discount_line', true); 
			$adf_discount_groupd_description = get_post_meta($post->ID, 'adf_discount_groupd_description', true);
			$gateways                        = $this->get_payment_gateways();
			$payment_gateways                = WC()->payment_gateways->get_available_payment_gateways();
			global $wp_roles;

			?>
			<div id="adf_gpby_product_data" class="panel woocommerce_options_panel">
				<div class="options_group">   
					<?php
					
					woocommerce_wp_checkbox( array( 
						'id'          => 'adf_gpby_show_form', 
						'label'       => esc_html__('Enable Group Buy', 'addify-group-buy-for-woocommerce'), 
						'description' => esc_html__('Select this checkbox to show group buy options.', 'addify-group-buy-for-woocommerce'),  
						'value'       => 'true',
						'desc_tip'    => 'true',
						'cbvalue'     => ( 'true' == $adf_gpby_show_form ) ? 'true' : '',
						'class'       => 'group-checkbox checktip',
					) ); 
					
					?>
					<div id="adf-gpby-product-lvl-form">
					<?php
						woocommerce_wp_checkbox( array( 
							'id'          => 'adf_gpby_allow_public_gp', 
							'label'       => esc_html__('Public Group', 'addify-group-buy-for-woocommerce'),
							'description' => esc_html__('Enable to allow public group creation (any registered user can join).', 'addify-group-buy-for-woocommerce'), 
							'value'       => 'true',
							'desc_tip'    => 'true',
							'cbvalue'     => ( 'true' == $adf_gpby_allow_public_gp ) ? 'true' : '',
							'class'       => 'group-checkbox checktip',
						) ); 

						woocommerce_wp_text_input(array(
							'id'                => 'adf_gpby_no_group',
							'label'             => esc_html__('Allow Number of Public Group', 'addify-group-buy-for-woocommerce'),
							'type'              => 'number',
							'desc_tip'          => 'true',
							'style'             => 'width:50%',
							'description'       => esc_html__('Add the number of public groups that can be created on a single product.', 'addify-group-buy-for-woocommerce'),
							'value'             => ( isset($adf_gpby_no_group) && !empty($adf_gpby_no_group) ? $adf_gpby_no_group : 1 ),
							'custom_attributes' => array(
								'min' => '1',
							),
						));

						woocommerce_wp_checkbox( array( 
							'id'          => 'adf_gpby_all_priv_grp', 
							'label'       => esc_html__('Private Group', 'addify-group-buy-for-woocommerce'), 
							'description' => esc_html__('Enable to allow private group creation (any registered user can join).', 'addify-group-buy-for-woocommerce'),
							'value'       => 'true',
							'desc_tip'    => 'true',
							'cbvalue'     => ( 'true' == $adf_gpby_all_priv_grp ) ? 'true' : '',
							'class'       => 'group-checkbox checktip',
						) );

						woocommerce_wp_text_input(array(
							'id'                => 'adf_gpby_private_no_group',
							'label'             => esc_html__('Allow Number of Private Group', 'addify-group-buy-for-woocommerce'),
							'type'              => 'number',
							'desc_tip'          => 'true',
							'style'             => 'width:50%',
							'description'       => esc_html__('Add the number of private groups that can be created on a single product.', 'addify-group-buy-for-woocommerce'),
							'value'             => ( isset($adf_gpby_private_no_group) && !empty($adf_gpby_private_no_group) ? $adf_gpby_private_no_group : 1 ),
							'custom_attributes' => array(
								'min' => '1',
							),
						));

						woocommerce_wp_text_input(array(
							'id'                => 'adf_gpby_total_group_member',
							'label'             => esc_html__('Group Member', 'addify-group-buy-for-woocommerce'),
							'type'              => 'number',
							'desc_tip'          => 'true',
							'description'       => esc_html__('Add the number of members required to complete a group.', 'addify-group-buy-for-woocommerce'),
							'value'             => ( isset($adf_gpby_total_group_member) && !empty($adf_gpby_total_group_member) ? $adf_gpby_total_group_member : 1 ),
							'custom_attributes' => array(
								'min' => '1',
							),
						));

						woocommerce_wp_text_input(array(
							'id'                => 'adf_gpby_group_act_no_days',
							'label'             => esc_html__('Days', 'addify-group-buy-for-woocommerce'),
							'type'              => 'number',
							'desc_tip'          => 'true',
							'description'       => esc_html__('Add number of days within which members are required to complete the group in order to get a discount.', 'addify-group-buy-for-woocommerce'),
							'value'             => ( isset($adf_gpby_group_act_no_days) && !empty($adf_gpby_group_act_no_days) ? $adf_gpby_group_act_no_days : 1 ),
							'custom_attributes' => array(
								'min' => '1',
							),
						));

						woocommerce_wp_select(array(
							'id'                => 'gpby_applied_user_roles[]',
							'label'             => esc_html__('Apply to User Roles', 'addify-group-buy-for-woocommerce'),
							'class'             => 'adf-gpby-live-search-for ct_hspm_categroy_live_search af-cp-prd-scroll wc-enhanced-select',
							'options'           => $wp_roles->get_names(),
							'value'             => $gpby_applied_user_roles,
							'style'             => 'width:50%',
							'desc_tip'          => 'true',
							'description'       => esc_html__('Select to offer group buying to specific user roles (leave empty to apply on all).', 'addify-group-buy-for-woocommerce'),
							'custom_attributes' => array(
								'multiple'         => 'multiple',
								'data-search_type' => 'userroles',
							),
						));

						woocommerce_wp_checkbox(
							array(
								'id'          => 'adf_gpby_sin_cus_enb',
								'label'       => esc_html__('Customer Restriction', 'addify-group-buy-for-woocommerce'),
								'description' => esc_html__('Check to restrict a user to buy multiple times in a group.', 'addify-group-buy-for-woocommerce'),
								'desc_tip'    => 'true',
								'value'       => 'true',
								'cbvalue'     => ( 'true' == $adf_gpby_sin_cus_enb ) ? 'true' : '',
								'class'       => 'checktip',
							)
						);

						woocommerce_wp_select(array(
							'id'          => 'adf_gpby_price_type',
							'label'       => esc_html__('Select Price Type', 'addify-group-buy-for-woocommerce'),
							'desc_tip'    => 'true',
							'description' => esc_html__('Choose whether to apply group buying discount on regular or sale prices.', 'addify-group-buy-for-woocommerce'),
							'options'     => array(
								'regprice' => esc_html__('Regular Price', 'addify-group-buy-for-woocommerce'),
								'salprice' => esc_html__('Sales Price', 'addify-group-buy-for-woocommerce'),
							),
							'value'       => $adf_gpby_price_type, 
						));

						woocommerce_wp_select(array(
							'id'          => 'adf_gpby_disc_type',
							'label'       => esc_html__('Select Discount Type', 'addify-group-buy-for-woocommerce'),
							'desc_tip'    => 'true',
							'description' => esc_html__('Choose whether to offer group purchase discount in percentage or amount.', 'addify-group-buy-for-woocommerce'),
							'options'     => array(
								'percent' => esc_html__('Percentage', 'addify-group-buy-for-woocommerce'),
								'fixed'   => esc_html__('Fixed', 'addify-group-buy-for-woocommerce'),
							),
							'value'       => $adf_gpby_disc_type, 
						));

						woocommerce_wp_text_input(array(
							'id'                => 'adf_gpby_discount_value',
							'label'             => esc_html__('Enter the Discount Value', 'addify-group-buy-for-woocommerce'),
							'type'              => 'number',
							'desc_tip'          => 'true',
							'description'       => esc_html__('Enter the discount value', 'addify-group-buy-for-woocommerce'),
							'value'             => ( isset($adf_gpby_discount_value) && !empty($adf_gpby_discount_value) ? $adf_gpby_discount_value : 0 ),
							'custom_attributes' => array(
								'min' => '0',
							),
						));

						woocommerce_wp_text_input(array(
							'id'          => 'adf_gpby_group_discount_line',
							'label'       => esc_html__('Group Discount Custom Text', 'addify-group-buy-for-woocommerce'),
							'type'        => 'text',
							'desc_tip'    => true,
							'style'       => 'width:50%',
							'description' => esc_html__('Add custom text that will be displayed in front of group title (You can use variables such as {discount_value} for your messages).', 'addify-group-buy-for-woocommerce'),
							'value'       => ( isset($adf_gpby_group_discount_line) && !empty($adf_gpby_group_discount_line) ? $adf_gpby_group_discount_line : 'Join this group and claim {discount_value}% discount.' ),
						));

					?>
					
						<div id="adf-group-desc-prduct-lvl">
							
							<div class="addify-gpby-prod_lvl_lbl"><?php echo esc_html__('Group Description', 'addify-group-buy-for-woocommerce'); ?></div>

							<span style="margin-left: 8%;">
								<?php
								$content = ( isset($adf_discount_groupd_description) && !empty($adf_discount_groupd_description) )? $adf_discount_groupd_description : 'Create a new group or join an existing one, and receive the product at a discount when the group sales goal is achieved.';
								wp_editor($content, 'adf_gpby_term_condition_desc', array( 
									'textarea_name' => 'adf_discount_groupd_description',
									'media_buttons' => false,
									'textarea_rows' => 15,
								));
								?>
							</span>
						</div>

						<?php
						woocommerce_wp_text_input(array(
							'id'    => 'adf_gpby_strt_date',
							'label' => esc_html__('Start Date of Rule', 'addify-group-buy-for-woocommerce'),
							'type'  => 'date',
							'value' => $adf_gpby_strt_date,
							'class' => 'adf-gpby-date',
						));
			
						woocommerce_wp_text_input(array(
							'id'    => 'adf_gpby_end_date',
							'label' => esc_html__('End Date of Rule', 'addify-group-buy-for-woocommerce'),
							'type'  => 'date',
							'value' => $adf_gpby_end_date,
							'class' => 'adf-gpby-date',
						));
					
						?>
					
					</div>
				</div>
			</div>
			<?php
		}
		

		public function adf_gpby_product_tab_data( $post_id ) {

			if (!isset($_POST['addify_gpby_meta_box_nonce'])) {
				return;
			}

			if (!wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['addify_gpby_meta_box_nonce'])), 'addify_gpby_meta_box')) {
				return;
			}

			if (isset($_POST['post_type']) && 'news' == $_POST['post_type']) {
				if (!current_user_can('edit_post', $post_id)) {
					return;
				}
			}

			//Save total number of memeber
			if ( isset( $_POST['adf_gpby_total_group_member'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_total_group_member', sanitize_text_field(wp_unslash($_POST['adf_gpby_total_group_member'])));
			} 

			//Save active number of days
			if ( isset( $_POST['adf_gpby_group_act_no_days'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_group_act_no_days', sanitize_text_field(wp_unslash($_POST['adf_gpby_group_act_no_days'])));
			}

			//Save allow public group
			$adf_gpby_show_form = isset($_POST['adf_gpby_show_form']) ? 'true' : '';
			update_post_meta($post_id, 'adf_gpby_show_form', $adf_gpby_show_form);

			//Save allow public group
			$adf_gpby_allow_public_gp = isset($_POST['adf_gpby_allow_public_gp']) ? 'true' : '';
			update_post_meta($post_id, 'adf_gpby_allow_public_gp', $adf_gpby_allow_public_gp);

			//Save no of private group allwed
			if ( isset( $_POST['adf_gpby_private_no_group'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_private_no_group', sanitize_text_field(wp_unslash($_POST['adf_gpby_private_no_group'])));
			}

			//Save no of public group
			if ( isset( $_POST['adf_gpby_no_group'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_no_group', sanitize_text_field(wp_unslash($_POST['adf_gpby_no_group'])));
			} 

			//save enable single customer
			$adf_gpby_sin_cus_enb = isset($_POST['adf_gpby_sin_cus_enb']) ? 'true' : 'false';
			update_post_meta($post_id, 'adf_gpby_sin_cus_enb', $adf_gpby_sin_cus_enb);

			//save Allow private group
			$adf_gpby_all_priv_grp = isset($_POST['adf_gpby_all_priv_grp']) ? 'true' : 'false';
			update_post_meta($post_id, 'adf_gpby_all_priv_grp', $adf_gpby_all_priv_grp);

				//save start date
			if ( isset( $_POST['adf_gpby_strt_date'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_strt_date', sanitize_text_field(wp_unslash($_POST['adf_gpby_strt_date'])));
			} 

			//save end date
			if ( isset( $_POST['adf_gpby_end_date'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_end_date', sanitize_text_field(wp_unslash($_POST['adf_gpby_end_date'])));
			} 

			// save pextentage type
			$adf_gpby_price_type = isset($_POST['adf_gpby_price_type']) ? sanitize_text_field(wp_unslash($_POST['adf_gpby_price_type'])) : '';
			update_post_meta($post_id, 'adf_gpby_price_type', $adf_gpby_price_type);

			// save pextentage type
			$adf_gpby_disc_type = isset($_POST['adf_gpby_disc_type']) ? sanitize_text_field(wp_unslash($_POST['adf_gpby_disc_type'])) : '';
			update_post_meta($post_id, 'adf_gpby_disc_type', $adf_gpby_disc_type);

			//save discount value
			if ( isset( $_POST['adf_gpby_discount_value'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_discount_value', sanitize_text_field(wp_unslash($_POST['adf_gpby_discount_value'])));
			} 

			//Save applied User roles
			if ( isset( $_POST['gpby_applied_user_roles'] ) ) {
				update_post_meta( $post_id, 'gpby_applied_user_roles', sanitize_meta('', wp_unslash($_POST['gpby_applied_user_roles']), '' ) );
			} else {
				delete_post_meta( $post_id, 'gpby_applied_user_roles' );
			}

			if ( isset( $_POST['adf_discount_groupd_description'] )) {
				update_post_meta( $post_id, 'adf_discount_groupd_description', sanitize_meta('', wp_unslash($_POST['adf_discount_groupd_description']), ''));
			}

			//Save no of public group
			if ( isset( $_POST['adf_gpby_group_discount_line'] ) ) {
				update_post_meta( $post_id, 'adf_gpby_group_discount_line', sanitize_text_field(wp_unslash($_POST['adf_gpby_group_discount_line'])));
			} 
		}

		public function get_payment_gateways() {
			$payment_gateways = WC()->payment_gateways->get_available_payment_gateways();
			$gateways         = array();
	
			foreach ( $payment_gateways as $gateway_id => $gateway ) {
				$gateways[ $gateway_id ] =  $gateway->get_title() ;
			}
			
			return $gateways;
		}
	}

	new Addify_Gpby_Product_Tab();
}