<?php

if (!defined('ABSPATH')) {
	exit();
}

if (!class_exists('Adf_Gpby_Account_Page')) :
	class Adf_Gpby_Account_Page {

		public function __construct() {
			$this->adf_gpby_Group_buy_endpoint();
			add_action('after_switch_theme', array( $this, 'adf_gpby_Group_flush_rewrite_rules' ));
			add_filter( 'query_vars', array( $this, 'adf_group_buy_query_vars' ), 0 ); 
			add_filter( 'woocommerce_account_menu_items', array( $this, 'adf_group_buy_link_my_account' ));
			add_action( 'woocommerce_account_group-buy_endpoint', array( $this, 'adf_group_buy_content' ));            
		}

		public function adf_gpby_Group_buy_endpoint() {
			add_rewrite_endpoint( 'group-buy', EP_ROOT | EP_PAGES );
			flush_rewrite_rules();
		}

		public function adf_gpby_Group_flush_rewrite_rules() {
			$this->adf_gpby_Group_buy_endpoint();
			flush_rewrite_rules();
		}

		public function adf_group_buy_query_vars( $vars ) {
			$vars[] = 'group-buy';
			return $vars;
		}

		public function adf_group_buy_link_my_account( $items ) {

			$current_user_id  = get_current_user_id();
			$current_user     = wp_get_current_user();
			$currentUserEmail = $current_user->user_email;

			$args = array(
				'post_type'      => 'addify_gpinfo',
				'post_status'    => 'publish',
				'posts_per_page' => -1,
				'orderby'        => 'menu_order',
				'order'          => 'ASC',
			);
		
			$getData        = new WP_Query($args);
			$filtered_posts = array();
		
			if ($getData->have_posts()) :
				$posts = $getData->get_posts();
				
				// Filter posts for which current user is in joinMemberInfo
				foreach ($posts as $post) :
					$joinMemberInfo  = get_post_meta($post->ID, 'adf_pgif_join_group_member_info', true);
					$invitedEmail    = get_post_meta($post->ID, 'adf_gpby_group_allow_users', true);
					$createGrpUserId = get_post_meta($post->ID, 'adf_pgif_user_id', true);
					$joinMember      = get_post_meta($post->ID, 'adf_pgif_group_join_memeber', true);
					
					if (!$joinMember || '' == $joinMember) :
						$joinMember = 0;
					endif;
					
					if (( $current_user_id == $createGrpUserId ) || ( isset($joinMemberInfo[0][4]) && $joinMemberInfo[0][4] == $current_user_id ) || ( in_array($currentUserEmail, $invitedEmail)  && 0 != $joinMember )) {
						$items['group-buy'] = 'Group Buying';
						$items              = array_merge(
							array_slice( $items, 0, array_search( 'customer-logout', array_keys( $items ) ) ),
							array( 'group-buy' => 'Group Buying' ),
							array_slice( $items, array_search( 'customer-logout', array_keys( $items ) ), count( $items ) )
						);
					} elseif (is_array($joinMemberInfo) && 1 < count($joinMemberInfo)) {
						foreach ($joinMemberInfo as $data) {
							if ($data[4] == $current_user_id) :
								$items['group-buy'] = 'Group Buying';
								$items              = array_merge(
									array_slice( $items, 0, array_search( 'customer-logout', array_keys( $items ) ) ),
									array( 'group-buy' => 'Group Buying' ),
									array_slice( $items, array_search( 'customer-logout', array_keys( $items ) ), count( $items ) )
								);
							endif;
						}
					}
					
				endforeach;
			endif;

		   

			return $items;
		}

		public function adf_group_buy_content() {

			$getSettingValue = get_option('adf_gpby_general_settings');
			$heading         = ( isset($getSettingValue['gp_by_accout_heading']) ? $getSettingValue['gp_by_accout_heading'] : 'All Groups' );
			$headingDesc     = ( isset($getSettingValue['gp_by_accout_dec']) ? $getSettingValue['gp_by_accout_dec'] : 'Following are the groups that you have either created, joined, or been invited to join.' );

			$current_user     = wp_get_current_user();
			$currentUserEmail = $current_user->user_email;
			$currentUSerId    = $current_user->ID;

			?>
			<div>
				<div>
					<h3><?php echo esc_html($heading); ?></h3>
				</div>
				<div>
					<p><?php echo esc_html($headingDesc); ?></p>
				</div>
				<div class="adf-gpby-acc-tab-container">
					<?php wp_nonce_field( 'adf_gpby_account_tab', 'adf_gpby_account_tab_nonce' ); ?>
					<div class="adf-gpby-acc-tab" data-tab="invited-group"><?php echo esc_html__('Invited Group', 'addify-group-buy-for-woocommerce'); ?></div>
					<div class="adf-gpby-acc-tab" data-tab="join-group"><?php echo esc_html__('Join Group', 'addify-group-buy-for-woocommerce'); ?></div>
					<div class="adf-gpby-acc-tab" data-tab="created-group"><?php echo esc_html__('Created Group', 'addify-group-buy-for-woocommerce'); ?></div>
				</div>

				<div id="invited-group" class="adf-gpby-acc-tab-content">
					<table>
						<thead>
							<tr>
								<th><?php echo esc_html__('Name', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Product', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Email', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Discount', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Member', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Status', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Action', 'addify-group-buy-for-woocommerce'); ?></th>
							</tr>
						</thead>
						<tbody>

						</tbody>
					
					</table>
					<div class="adf-invite-pagination"></div>
				</div>

				<div id="join-group" class="adf-gpby-acc-tab-content">
					<table>
						<thead>
							<tr>
								<th><?php echo esc_html__('Name', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Product', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Created By', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Discount', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Member', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Status', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Action', 'addify-group-buy-for-woocommerce'); ?></th>
							</tr>
						</thead>

						<tbody>
							
						</tbody>
					</table>
					<div class="adf-join-pagination"></div>
				</div>
			
				<div id="created-group" class="adf-gpby-acc-tab-content">
					<table>
						<thead>
							<tr>
								<th><?php echo esc_html__('Name', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Product', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Discount', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Member', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Status', 'addify-group-buy-for-woocommerce'); ?></th>
								<th><?php echo esc_html__('Action', 'addify-group-buy-for-woocommerce'); ?></th>
							</tr>
						</thead>

						<tbody>
							
						</tbody>
					
					</table>
					<div class="adf-create-pagination"></div>
				</div>
			</div>
		<?php
		}
	}
	new Adf_Gpby_Account_Page();
endif;