<?php


if (!defined('ABSPATH')) {
	exit();
}

if (!class_exists('Adf_Gpby_Front')) :

	class Adf_Gpby_Front {
		public function __construct() {
			
			$this->adf_gpby_call_hook_filter();
			$this->include_files();
		}

		public function adf_gpby_call_hook_filter() {
			add_action('woocommerce_after_shop_loop_item', array( $this, 'add_group_custom_button' ), 20 );
			add_action( 'wp_enqueue_scripts', array( $this, 'adf_register_wprs' ));
			add_action( 'woocommerce_before_shop_loop', array( $this, 'adf_gpby_woocommerce_before_shop_loop_action' ) );
		}

		public function include_files() {
			$getSettingValue = get_option('adf_gpby_general_settings');
			$enableTab       = ( isset($getSettingValue['adf_gpby_enable_tab']) ? $getSettingValue['adf_gpby_enable_tab'] : false );
			
			if ($enableTab) {
				include_once AF_GPBY_DIR . 'includes/front/adf_gpby_account_page.php';
			}

			//include_once AF_GPBY_DIR . 'includes/front/adf_gpby_login.php';
			include_once AF_GPBY_DIR . 'includes/front/adf_gpby_product_detail.php';
			include_once AF_GPBY_DIR . 'includes/front/adf_gpby_cart_validation.php';
		}

		public function adf_register_wprs() {
			wp_enqueue_script(
				'flipdown-js',
				AF_GPBY_URL . 'assets/flipdown.js',
				null, 
				'1.0.0', 
				true 
			);
		
			wp_enqueue_script(
				'adf_gpby_front_js_call',
				AF_GPBY_URL . 'assets/js/front.js',
				array( 'jquery', 'flipdown-js' ),
				'1.0.0',
				true 
			);
	
			wp_enqueue_style(
				'flipdown-css',
				AF_GPBY_URL . 'assets/flipdown.css',
				array(),
				'1.0.0'
			);
	
			wp_enqueue_style(
				'adf_gpby-stylesheet', 
				AF_GPBY_URL . 'assets/css/front.css',
				array( 'flipdown-css' ), 
				'1.0.0'
			);

			$js_data = array(
				'ajax_url' => admin_url('admin-ajax.php'),
				'nonce'    => wp_create_nonce('adf_gpby_group_form'),
				'nonceTab' => wp_create_nonce('adf_gpby_account_tab'),

			);
			wp_localize_script( 'adf_gpby_front_js_call', 'adf_gpby_js_var', $js_data );
		} 
		
		public function adf_gpby_woocommerce_before_shop_loop_action() {
			?>
				<div id="adf-gpby-message_custom" class="adf-gpby-message_custom adf-gpby-message_custom_sp_pg"></div>
				<div id="adf-gpby-message_error_custom" class="adf-gpby-message_error_custom adf-gpby-message_custom_sp_pg"></div>
			<?php
		}

		public function add_group_custom_button() {
			global $product;

			if ( $product->is_type('variable') || $product->is_type('grouped') ) { 
			return;
			}

			if (!$product->is_in_stock()) {
				return;
			}
			
			$creatJoinDuplicateBtn = false;
			$getProdLink           = get_permalink();
			$ruleFlag              = false;
			$disableBtn            = false;
			$product_id            = $product->get_id();
			$product_name          = $product->get_name();
			$user_id               = get_current_user_id();
			$currentnUserRole      = $this->get_current_user_role();

			if (!is_user_logged_in()) {
				$loginUrl = wc_get_page_permalink('myaccount');
			}

			$getSettingValue   = get_option('adf_gpby_general_settings');
			$progrssBarSett    = ( isset($getSettingValue['adf_gpby_progrss_bar_pd_det_pg']) ? $getSettingValue['adf_gpby_progrss_bar_pd_det_pg'] : true );
			$timmerSett        = ( isset($getSettingValue['adf_gpby_timmer_enabler_pd_dt']) ? $getSettingValue['adf_gpby_timmer_enabler_pd_dt'] : true );
			$sociallinkSett    = ( isset($getSettingValue['adf_gpby_social_lk_enbl_pd_dtl']) ? $getSettingValue['adf_gpby_social_lk_enbl_pd_dtl'] : true );
			$enableCreatorName = ( isset($getSettingValue['adf_gpby_creater_name']) ? $getSettingValue['adf_gpby_creater_name'] : true );
			$groupTerms        = ( isset($getSettingValue['adf_gpby_term_condition']) ? $getSettingValue['adf_gpby_term_condition'] : '' );
			$groupDescription  = ( isset($getSettingValue['adf_gpby_term_condition_desc']) ? $getSettingValue['adf_gpby_term_condition_desc'] : '' );
			$counterOption     = ( isset($getSettingValue['adf_gpby_counter_option']) ? $getSettingValue['adf_gpby_counter_option'] : 'counter' );

			$enable_rule = get_post_meta($product_id, 'adf_gpby_show_form', true); 
			if (isset($enable_rule) && $enable_rule) :
		
				$adf_gpby_no_group           = get_post_meta($product_id, 'adf_gpby_no_group', true); 
				$adf_gpby_private_no_group   = get_post_meta($product_id, 'adf_gpby_private_no_group', true);
				$adf_gpby_allow_public_gp    = get_post_meta($product_id, 'adf_gpby_allow_public_gp', true); 
				$adf_gpby_total_group_member = get_post_meta($product_id, 'adf_gpby_total_group_member', true);
				$adf_gpby_group_act_no_days  = get_post_meta($product_id, 'adf_gpby_group_act_no_days', true); 
				$adf_gpby_sin_cus_enb        = get_post_meta($product_id, 'adf_gpby_sin_cus_enb', true);
				$adf_gpby_all_priv_grp       = get_post_meta($product_id, 'adf_gpby_all_priv_grp', true);
				$adf_gpby_strt_date          =  get_post_meta( $product_id, 'adf_gpby_strt_date', true ); 
				$adf_gpby_end_date           =  get_post_meta( $product_id, 'adf_gpby_end_date', true ); 
				$adf_gpby_disc_type          = get_post_meta($product_id, 'adf_gpby_disc_type', true); 
				$adf_gpby_price_type         = get_post_meta($product_id, 'adf_gpby_price_type', true); 
				$adf_gpby_discount_value     = get_post_meta($product_id, 'adf_gpby_discount_value', true);
				$gpby_applied_user_roles     =  (array) get_post_meta( $product_id, 'gpby_applied_user_roles', true );
				$currentnUserRole            = $this->get_current_user_role();
				$groupCreationUser           = (array) get_post_meta($product_id, 'create_group_user_id_', true);
				$current_datetime            = current_datetime()->format('Y-m-d');

				$start_rule_dt = new DateTime($adf_gpby_strt_date);
				$end_rule_dt   = new DateTime($adf_gpby_end_date);
				$current_dt    = new DateTime($current_datetime);
				$dateInterval  = $start_rule_dt->diff($end_rule_dt);
				$ruleDateDays  = $dateInterval->days;
				$group_id      = $user_id . '_group_' . $product_id;

				$parent_post_id = $product_id;
				$groupInfoCount = $this->getGroupInfoData($product_id, $parent_post_id);

				

				if (
					$current_dt >= $start_rule_dt &&
					$current_dt <= $end_rule_dt &&
					(
						( isset($groupInfoCount['noOfpublicGrp']) &&
						'true' == $adf_gpby_allow_public_gp &&
						$groupInfoCount['noOfpublicGrp'] != $adf_gpby_no_group ) ||
						( isset($groupInfoCount['noOfprivateGrp']) &&
						'true' == $adf_gpby_all_priv_grp &&
						$groupInfoCount['noOfprivateGrp'] != $adf_gpby_private_no_group )
					)
				) :
				
					if (in_array($currentnUserRole, $gpby_applied_user_roles) || empty($gpby_applied_user_roles[0])) :
						$creatJoinDuplicateBtn = true;
				
						if (0 === $user_id) :
							?>
							<a href="<?php echo esc_attr($loginUrl); ?>"><p class="button adf-gpby-login-custom-button"> <?php echo esc_html__('Log In to join/create group', 'addify-group-buy-for-woocommerce'); ?></p></a> 
							<?php
							return;
						endif;
						?>
						<button class="adf-gpby-sp-pg-cret-join-grp" data-value="<?php echo esc_attr($product_id); ?>"> <?php echo esc_html__('Create/join group', 'addify-group-buy-for-woocommerce'); ?></button>
						<div class="af-gpby-main-conatiner-shop-page adf-main-popup-<?php echo esc_attr($product_id); ?>">
							<div class="adf-gpby-close-form-shp-pg adf-gpby-cls-icon">&times;</div>
							<div><?php echo esc_html__('With group buy, create groups and claim discount on desired products. Just create or join a group and invite your friends and family to join, once the group is completed all members will get goods at discount rates.', 'addify-group-buy-for-woocommerce'); ?></div>
							<div class="adf-gp-by-sp-pg-btn-Container">
								<div style="margin-bottom:10px;">
									<a href= <?php echo esc_attr(get_permalink($product->get_id())); ?>><p class="button adf-gpby-create-grp-button alt"><?php echo esc_html__('Create Group', 'addify-group-buy-for-woocommerce'); ?></p></a>
								</div>
								<div style="margin-bottom:10px;">
									<p class="adf-gpby-join-custom-button button alt" data-value="<?php echo esc_attr($product_id); ?>"> <?php echo esc_html__('Join Group', 'addify-group-buy-for-woocommerce'); ?></p>
								</div>
							</div>
						</div> 
						<?php
						$ruleFlag = true; 
					endif;
					wp_reset_postdata();
				endif;
			endif;  
				
			if (false === $ruleFlag) :

				$terms = get_the_terms( $product_id , 'product_cat' );
				if ( !empty( $terms ) ) {
					foreach ( $terms as $term ) {
						$cat_Id = $term->term_id;
					}
				}
				
				$args  = array(
					'post_type'      => 'addify_gpby',
					'posts_per_page' => -1,
					'orderby'        => 'menu_order',
					'order'          => 'ASC',
					'meta_query'     => array(
						array(
							'relation' => 'OR',
							array(
								'key'     => 'gpby_applied_categories',
								'value'   => $cat_Id,
								'compare' => 'LIKE',
							),
							array(
								'key'     => 'gpby_applied_products',
								'value'   => $product_id,
								'compare' => 'LIKE',
							), 
							array(
								'key'     => 'adf_gpby_prod_check',
								'value'   => 'true',
								'compare' => '=',
							),
						),
						array(
							'relation' => 'OR',
							array(
								'key'     => 'gpby_applied_user_roles',
								'value'   => $currentnUserRole,
								'compare' => 'LIKE',
							),
							array(
								'relation' => 'OR',
								array(
									'key'     => 'gpby_applied_user_roles',
									'compare' => 'NOT EXISTS',
								),
								array(
									'key'     => 'gpby_applied_user_roles',
									'value'   => '',
									'compare' => '=', 
								),
							),
						),
					),
				);
				$query = new WP_Query($args);
				
				if ($query->have_posts()) :
				   
					while ($query->have_posts()) :
						$query->the_post();
						$post_id = get_the_ID();
						 
						$adf_gpby_no_group            =  intval(get_post_meta( $post_id, 'adf_gpby_no_group', true )); 
						$adf_gpby_private_no_group    =  intval(get_post_meta( $post_id, 'adf_gpby_private_no_group', true )); 
						$adf_gpby_allow_public_gp     =  get_post_meta( $post_id, 'adf_gpby_allow_public_gp', true );
						$adf_gpby_all_priv_grp        =  get_post_meta( $post_id, 'adf_gpby_all_priv_grp', true );
						$adf_gpby_order_status        = get_post_meta($post_id, 'adf_gpby_order_status', true); 
						$adf_gpby_sin_cus_enb         = get_post_meta($post_id, 'adf_gpby_sin_cus_enb', true); 
						$adf_gpby_enb_refund          = get_post_meta($post_id, 'adf_gpby_enb_refund', true);
						$adf_gpby_strt_date           =  get_post_meta( $post_id, 'adf_gpby_strt_date', true ); 
						$adf_gpby_end_date            =  get_post_meta( $post_id, 'adf_gpby_end_date', true ); 
						$adf_gpby_gp_desc             =  get_post_meta( $post_id, 'adf_gpby_gp_desc', true ); 
						$adf_gpby_disc_type           = get_post_meta($post_id, 'adf_gpby_disc_type', true);
						$adf_gpby_group_act_no_days   = get_post_meta($post_id, 'adf_gpby_group_act_no_days', true); 
						$adf_gpby_total_group_member  = get_post_meta($post_id, 'adf_gpby_total_group_member', true);
						$current_datetime             = current_datetime()->format('Y-m-d');
						$adf_gpby_discount_value      = get_post_meta($post_id, 'adf_gpby_group_discount_value', true);
						$adf_gpby_price_type          = get_post_meta($post_id, 'adf_gpby_price_type', true); 
						$adf_gpby_group_discount_line = get_post_meta($post_id, 'adf_gpby_group_discount_line', true);
						$groupCreationUser            = (array) get_post_meta($post_id, 'create_group_user_id_', true);
						$start_rule_dt                = new DateTime($adf_gpby_strt_date);
						$end_rule_dt                  = new DateTime($adf_gpby_end_date);
						$current_dt                   = new DateTime($current_datetime);
						$dateInterval                 = $start_rule_dt->diff($end_rule_dt);
						$ruleDateDays                 = $dateInterval->days;
						$group_id                     = $user_id . '_group_' . $product_id;

						$parent_post_id = $post_id;
						$groupInfoCount = $this->getGroupInfoData($product_id, $parent_post_id);
						
						if (
							$current_dt >= $start_rule_dt &&
							$current_dt <= $end_rule_dt &&
							(
								( isset($groupInfoCount['noOfpublicGrp']) &&
								'true' == $adf_gpby_allow_public_gp &&
								$groupInfoCount['noOfpublicGrp'] != $adf_gpby_no_group ) ||
								( isset($groupInfoCount['noOfprivateGrp']) &&
								'true' == $adf_gpby_all_priv_grp &&
								$groupInfoCount['noOfprivateGrp'] != $adf_gpby_private_no_group )
							)
						) :   
							if (false === $creatJoinDuplicateBtn) :
								if (0 === $user_id) :
									?>
									<a href="<?php echo esc_attr($loginUrl); ?>"><p class="button adf-gpby-login-custom-button"> <?php echo esc_html__('Log In to join/create group', 'addify-group-buy-for-woocommerce'); ?></p></a> 
									<?php
									return;
								endif;
								?>
							<button class="adf-gpby-sp-pg-cret-join-grp" data-value="<?php echo esc_attr($product_id); ?>"> <?php echo esc_html__('Create/join group', 'addify-group-buy-for-woocommerce'); ?></button>
							<div id="adf-gpby-overlay" class="adf-gpby-overlay"></div>
							<div class="af-gpby-main-conatiner-shop-page adf-main-popup-<?php echo esc_attr($product_id); ?>">
								<div class="adf-gpby-close-form-shp-pg adf-gpby-cls-icon">&times;</div>
								<div><?php echo esc_html__('With group buy, create groups and claim discount on desired products. Just create or join a group and invite your friends and family to join, once the group is completed all members will get goods at discount rates.', 'addify-group-buy-for-woocommerce'); ?></div>
								<div class="adf-gp-by-sp-pg-btn-Container">
									<div style="margin-bottom:10px;">
										<a href= <?php echo esc_attr(get_permalink($product->get_id())); ?>><p class="button adf-gpby-create-grp-button alt"><?php echo esc_html__('Create Group', 'addify-group-buy-for-woocommerce'); ?></p></a>
									</div>
									<div style="margin-bottom:10px;">
										<p class="adf-gpby-join-custom-button button alt" data-value="<?php echo esc_attr($product_id); ?>"> <?php echo esc_html__('Join Group', 'addify-group-buy-for-woocommerce'); ?></p>
									</div>
								</div>
							</div> 
							<?php
							$creatJoinDuplicateBtn = true;
							endif;
						endif;
					endwhile;
				endif;
			endif;

			$getGroupDatas = (array) get_post_meta( $product_id, 'adf_gpby_cutomer_create_group', true); 
			$current_user  = wp_get_current_user();
			$args          = array(
				'post_type'      => 'addify_gpinfo',
				'posts_per_page' => -1,
				'post_status'    => 'publish',
				'meta_query'     => array(
					array(
						'key'     => 'adf_pgif_product_id',
						'value'   => $product_id,
						'compare' => '=',
					),
					array(
						'key'     => 'adf_gpby_group_info_status',
						'value'   => 'processing',
						'compare' => '=',
					),
					array(
						'relation' => 'OR',
						array(
							'key'     => 'adf_order_showing',
							'value'   => 'true',
							'compare' => '=',
						),
						array(
							'key'     => 'adf_created_group_email',
							'value'   => $current_user->user_email,
							'compare' => '=',
						),
					),
				),
			);
			$query         = new WP_Query($args);
			if ($query->have_posts()) :
				$index               = 0; 
				$getNumberOfcustomer = 0; 
				$showGroupflag       = false;
				?>
				<div>
					<?php
					if (false === $creatJoinDuplicateBtn) :
						if (0 === $user_id) :
							?>
						<a href="<?php echo esc_attr($loginUrl); ?>"><p class="button adf-gpby-login-custom-button"> <?php echo esc_html__('Log In to join/create group', 'addify-group-buy-for-woocommerce'); ?></p></a> 
						<?php
						return;
					endif;
						?>
						<button class="adf-gpby-sp-pg-cret-join-grp" data-value="<?php echo esc_attr($product_id); ?>"> <?php echo esc_html__('Create/join group', 'addify-group-buy-for-woocommerce'); ?></button>
						<div class="af-gpby-main-conatiner-shop-page adf-main-popup-<?php echo esc_attr($product_id); ?>">
								<div class="adf-gpby-close-form-shp-pg adf-gpby-cls-icon">&times;</div>
								<div><?php echo esc_html__('With group buy, create groups and claim discount on desired products. Just create or join a group and invite your friends and family to join, once the group is completed all members will get goods at discount rates.', 'addify-group-buy-for-woocommerce'); ?></div>
								<div class="adf-gp-by-sp-pg-btn-Container">
									<div style="margin-bottom:10px;">
										<a href= <?php echo esc_attr(get_permalink($product->get_id())); ?>><p class="button adf-gpby-create-grp-button alt"><?php echo esc_html__('Create Group', 'addify-group-buy-for-woocommerce'); ?></p></a>
									</div>
									<div style="margin-bottom:10px;">
										<p class="adf-gpby-join-custom-button button alt" data-value="<?php echo esc_attr($product_id); ?>"> <?php echo esc_html__('Join Group', 'addify-group-buy-for-woocommerce'); ?></p>
									</div>
							</div>
						</div>
					<?php endif; ?>
					<div class="adf-gpby-created-grup_container adf-groups-prod-<?php echo esc_attr($product_id); ?>">
					<div class="adf-gpby-close-form-shp-pg adf-gpby-cls-icon">&times;</div>
				<?php

				$showEmptyPrivate = false;
				while ($query->have_posts()) :
	
					++$index;
					$groupInfoStatus = 'processing';
					$query->the_post();
					$post_id = get_the_ID();

					$groupType             = get_post_meta($post_id, 'adf_pgif_group_type', true);
					$groupName             = get_post_meta($post_id, 'adf_pgif_group_name', true);
					$endGroupTime          = get_post_meta($post_id, 'adf_pgif_group_exprire', true);
					$authurName            = get_post_meta($post_id, 'adf_pgif_group_auth', true);
					$groupJoingMember      = get_post_meta($post_id, 'adf_pgif_join_group_member_info', true);
					$groupInfoStatus       = get_post_meta( $post_id, 'adf_gpby_group_info_status', true);
					$allowEmail            = get_post_meta($post_id, 'adf_gpby_group_allow_users', true);
					$getNumberOfcustomer   = intval(get_post_meta($post_id, 'adf_pgif_group_join_memeber', true));
					$group_id              = get_post_meta($post_id, 'adf_pgif_group_id', true);
					$discpuntPrice         = get_post_meta($post_id, 'adf_pgif_group_price', true);
					$createdCustomerMsg    = get_post_meta($post_id, 'adf_created_member_msg', true);
					$createdGroupUsers     = get_post_meta($post_id, 'adf_pgif_user_id', true);
					$adf_gpif_group_member = intval(get_post_meta($post_id, 'adf_gpif_group_member', true));
					$group_create_num      = $group_id;
					$end_group_time        = new DateTime($endGroupTime);
					$currentTime           = new DateTime();

					
					if ('qualified' == $groupInfoStatus || 'disqualified' == $groupInfoStatus) :
						continue;
					endif;

			
					if (!isset($getNumberOfcustomer)) :
						$getNumberOfcustomer = 0;
					endif;
					
					if ('public' === $groupType) : 
						$showEmptyPrivate = true;
						?>
						
						<div class="adf-gpby-group-container-main">
							<form class="form-ofgroup-container">
								<div>
									<input type="hidden" name="adf_gpby_group_form" value="<?php echo esc_html(wp_create_nonce('adf_gpby_group_form')); ?>">
									<input id="adf-gpby-single-cus-enable" class="adf-gpby-single-cus-enable" type="hidden" name="adf_gpby_sing_cust_enable" value=" <?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" >
									<input id="adf-group-number" class="adf-group-number" type="hidden" name="adf_group_number" value=" <?php echo esc_attr($group_create_num); ?>" >
									<input id="adf-timer-end-rule" class="adf-timer-end-rule" type="hidden" name="adf_end_date_time" value=" <?php echo esc_attr($endGroupTime); ?>" >
									<input id="adf-gpby-group-id" class="adf-gpby-group-id" type="hidden" name="adf_gpby_group_id" value=" <?php echo esc_attr($group_id); ?>" >
									<input id="adf-tol-num-member" class="adf-tol-num-member" type="hidden" name="adf_tol_num_member" value=" <?php echo esc_attr($adf_gpby_total_group_member); ?>" >
									<input id="adf-purchase-member" class="adf-purchase-member" type="hidden" name="adf_purcahse_num_member" value=" 
									<?php
									if (isset($getNumberOfcustomer)) {
echo esc_attr($getNumberOfcustomer);}
									?>
									" >
									<input id="adf-gpby_product_Id" class="adf-gpby_product_Id" type="hidden" name="adf_product_Id" value=" <?php echo esc_attr($product->get_id()); ?>" >
									<input id="adf-gpby_product_Id" class="adf-gpby_product_Id" type="hidden" name="adf_single_customer_en" value=" <?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" >
									<div class="adf-gpby-pg_bar_gp_btn_shp_pg">
										<div class="adf-gpby-sh-pg-group-info">
											<div class="adf-gpby-group_name"><?php echo esc_html($groupName); ?></div>
											<?php if ('true' === $enableCreatorName) : ?>
												<div><?php echo esc_html__('Created by: ', 'addify-group-buy-for-woocommerce'); ?><?php echo esc_html($authurName); ?></div>
											<?php endif; ?>
											<span><?php echo esc_html__('Group Expires in:', 'addify-group-buy-for-woocommerce'); ?></span>
											<span class="adf-gpby_timmer" data-end-time="<?php echo esc_attr($endGroupTime); ?>"></span>
											<div>
											<?php
											echo esc_html(intval($adf_gpif_group_member) - $getNumberOfcustomer);
echo esc_html__(' Membere Remianing to claim this Deal', 'addify-group-buy-for-woocommerce');
											?>
											</div>
											<div id="adf-gpby-myProgress">
												<div class="adf-progress-bar" id="adf-progress-bar"></div>
											</div>
										</div>  
										<div class="adf-gpby-gpbuy-share-btns">  
											<div><button class="adf-gpby-add-to-cart adf-gpby-btn-popup" data-product-id= "<?php echo esc_attr($product->get_id()); ?>" data-group-id="<?php echo esc_attr($group_id); ?>" data-group-num="<?php echo esc_attr($group_create_num); ?>" data-sing-cust-enable="<?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" 
																																		<?php
																																		if (true === $disableBtn) {
																							echo 'disabled';}
																																		?>
											> <?php echo esc_html__('Group Buying', 'addify-group-buy-for-woocommerce'); ?></button></div> 
											<div class="adf-gpby-social_con_in_popup">
												<div id="adf-gpby-social_btn_<?php echo esc_attr($index); ?>" class="adf-gpby-social_btn" data-target="#adf-gpby-social_link_popup_id_<?php echo esc_attr($index); ?>"><?php echo esc_html__('Share Group', 'addify-group-buy-for-woocommerce'); ?></div>
												<div id="adf-gpby-social_link_popup_id_<?php echo esc_attr($index); ?>" class="adf-gpby-social_link_popup">
													<a href="https://twitter.com/intent/tweet?url=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/twitter.png'); ?>" alt="Socail icon"></a>
													<a href="http://www.facebook.com/sharer/sharer.php?u=<?php echo esc_attr($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/fb.png'); ?>" alt="Socail icon"></a>
													<a href="https://www.linkedin.com/sharing/share-offsite/?url=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/linkedin.png'); ?>" alt="Socail icon"></a>
													<a href="mailto:?subject=Check this out&body=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/emial.png'); ?>" alt="Socail icon"></a>
												</div>
											</div>
										</div>
									</div>
								</div>
							</form>
						</div>
						<?php   
					elseif ('private' === $groupType) : 
						$showEmptyPrivate = true;
						$current_user     = wp_get_current_user();
						if (is_array($allowEmail)) :
							if (in_array($current_user->user_email, $allowEmail)) : 
								?>
									<div class="adf-gpby-group-container-main">
										<form class="form-ofgroup-container">
											<div>
												<div>
													<input type="hidden" name="adf_gpby_group_form" value="<?php echo esc_html(wp_create_nonce('adf_gpby_group_form')); ?>">
													<input id="adf-gpby-single-cus-enable" class="adf-gpby-single-cus-enable" type="hidden" name="adf_gpby_sing_cust_enable" value=" <?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" >
													<input id="adf-group-number" class="adf-group-number" type="hidden" name="adf_group_number" value=" <?php echo esc_attr($group_create_num); ?>" >
													<input id="adf-timer-end-rule" class="adf-timer-end-rule" type="hidden" name="adf_end_date_time" value=" <?php echo esc_attr($endGroupTime); ?>" >
													<input id="adf-gpby-group-id" class="adf-gpby-group-id" type="hidden" name="adf_gpby_group_id" value=" <?php echo esc_attr($group_id); ?>" >
													<input id="adf-tol-num-member" class="adf-tol-num-member" type="hidden" name="adf_tol_num_member" value=" <?php echo esc_attr($adf_gpby_total_group_member); ?>" >
													<input id="adf-purchase-member" class="adf-purchase-member" type="hidden" name="adf_purcahse_num_member" value=" 
													<?php
													if (isset($getNumberOfcustomer)) {
echo esc_attr($getNumberOfcustomer);}
													?>
													" >
													<input id="adf-gpby_product_Id" class="adf-gpby_product_Id" type="hidden" name="adf_product_Id" value=" <?php echo esc_attr($product->get_id()); ?>" >
													<input id="adf-gpby_product_Id" class="adf-gpby_product_Id" type="hidden" name="adf_single_customer_en" value=" <?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" >
													<div class="adf-gpby-pg_bar_gp_btn_shp_pg">
														<div class="adf-gpby-sh-pg-group-info">
															<div class="adf-gpby-group_name"><?php echo esc_html($groupName); ?></div>
															<?php if ('true' === $enableCreatorName) : ?>
																<div><?php echo esc_html__('Created by: ', 'addify-group-buy-for-woocommerce'); ?><?php echo esc_html($authurName); ?></div>
															<?php endif; ?>
															<span><?php echo esc_html__('Group Expires in:', 'addify-group-buy-for-woocommerce'); ?></span>
															<span class="adf-gpby_timmer" data-end-time="<?php echo esc_attr($endGroupTime); ?>"></span>
															<div>
															<?php
															echo esc_html(intval($adf_gpif_group_member) - $getNumberOfcustomer);
echo esc_html__(' Membere Remianing to claim this Deal', 'addify-group-buy-for-woocommerce');
															?>
															</div>
															<div id="adf-gpby-myProgress">
																<div class="adf-progress-bar" id="adf-progress-bar"></div>
															</div>
														</div>  
														<div class="adf-gpby-gpbuy-share-btns">  
															<div><button class="adf-gpby-add-to-cart adf-gpby-btn-popup" data-product-id= "<?php echo esc_attr($product->get_id()); ?>" data-group-id="<?php echo esc_attr($group_id); ?>" data-group-num="<?php echo esc_attr($group_create_num); ?>" data-sing-cust-enable="<?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" 
																																						<?php
																																						if (true === $disableBtn) {
																							echo 'disabled';}
																																						?>
															> <?php echo esc_html__('Group Buying', 'addify-group-buy-for-woocommerce'); ?></button></div> 
															<div calss="adf-gpby-social_con_in_popup">
																<div id="adf-gpby-social_btn_<?php echo esc_attr($index); ?>" class="adf-gpby-social_btn" data-target="#adf-gpby-social_link_popup_id_<?php echo esc_attr($index); ?>"><?php echo esc_html__('Share Group', 'addify-group-buy-for-woocommerce'); ?></div>
																<div id="adf-gpby-social_link_popup_id_<?php echo esc_attr($index); ?>" class="adf-gpby-social_link_popup">
																	<a href="https://twitter.com/intent/tweet?url=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/twitter.png'); ?>" alt="Socail icon"></a>
																	<a href="http://www.facebook.com/sharer/sharer.php?u=<?php echo esc_attr($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/fb.png'); ?>" alt="Socail icon"></a>
																	<a href="https://www.linkedin.com/sharing/share-offsite/?url=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/linkedin.png'); ?>" alt="Socail icon"></a>
																	<a href="mailto:?subject=Check this out&body=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/emial.png'); ?>" alt="Socail icon"></a>
																</div>
															</div>
														</div>
													</div>
												</div>
											</div>
										</form>
									</div>
								<?php
								
							elseif (false == $showEmptyPrivate) :
								?>
									<div class="adf-gpby-close-form-shp-pg adf-gpby-cls-icon">&times;</div>
									<div> <?php echo esc_html__('No group have been created against this product yet. Create a group now and invite members to claim the group buying discount.', 'addify-group-buy-for-woocommerce'); ?></div>
									<div style="margin-top:20px;">
										<a href= <?php echo esc_attr(get_permalink($product->get_id())); ?>><p class="button adf-gpby-create-grp-button alt"><?php echo esc_html__('Create Group', 'addify-group-buy-for-woocommerce'); ?></p></a>
									</div>
								<?php	
							endif;
						endif;
					endif; 
				endwhile;
				?>
				</div>
				<?php
			else :
				?>
					<div class="adf-gpby-created-grup_container adf-groups-prod-<?php echo esc_attr($product_id); ?>">
						<div class="adf-gpby-close-form-shp-pg adf-gpby-cls-icon">&times;</div>
						<div> <?php echo esc_html__('No group have been created against this product yet. Create a group now and invite members to claim the group buying discount.', 'addify-group-buy-for-woocommerce'); ?></div>
						<div style="margin-top:20px;">
							<a href= <?php echo esc_attr(get_permalink($product->get_id())); ?>><p class="button adf-gpby-create-grp-button alt"><?php echo esc_html__('Create Group', 'addify-group-buy-for-woocommerce'); ?></p></a>
						</div>
					</div>
				<?php
			endif;    
		}
		
		public function get_current_user_role() {
			global $wp_roles;
			if ( is_user_logged_in() ) {
			$user  = wp_get_current_user();
			$roles = ( array ) $user->roles;
			$role  = $roles[0];
			return $role;
			} else {
			return 'guest';
			}
		}

		public function getGroupInfoData( $product_id, $parent_post_id ) {
			$totalNoOfGrp       = array(
				'noOfpublicGrp'  => 0,
				'noOfprivateGrp' => 0,
			);
				$noOfpublicGrp  = 0;
				$noOfprivateGrp = 0;
				$args           = array(
					'post_type'      => 'addify_gpinfo',
					'posts_per_page' => -1,
					'post_status'    => 'publish',
					'post_parent'    => $parent_post_id,
					'meta_query'     => array(
						array(
							'key'     => 'adf_pgif_product_id',
							'value'   => $product_id,
							'compare' => '=',
						),
					),
				);

				$query = new WP_Query($args);
				if ($query->have_posts()) {
					while ($query->have_posts()) :
						$query->the_post();
						$post_id = get_the_ID();

						$groupType = get_post_meta($post_id, 'adf_pgif_group_type', true);
						if ('public' === $groupType) :
							++$noOfpublicGrp;
					elseif ('private' === $groupType) :
							++$noOfprivateGrp;
					endif;
					endwhile;
					$totalNoOfGrp = array(
						'noOfpublicGrp'  => $noOfpublicGrp,
						'noOfprivateGrp' => $noOfprivateGrp,
					);
				}
			
			return $totalNoOfGrp;
		}
	}

	new Adf_Gpby_Front();
endif;
