<?php

if (!defined('ABSPATH')) {
	exit();
}

add_action('template_redirect', 'adf_gpby_previous_url_in_session');
add_filter('woocommerce_login_redirect', 'adf_gpby_redirect_to_previous_page');
add_filter( 'woocommerce_registration_redirect', 'custom_redirection_after_registration', 10, 1 );

function adf_gpby_previous_url_in_session() {
	if (!is_user_logged_in() && !is_account_page()) {
		if (!session_id()) {
			session_start();
		}
		if (isset($_SERVER['REQUEST_URI'])) {
			$_SESSION['previous_url'] = esc_url_raw(wp_unslash($_SERVER['REQUEST_URI']));
		}
	}
}


function adf_gpby_redirect_to_previous_page( $redirect_to ) {
	if ( ! session_id() ) {
		session_start();
	}

	$previous_url = isset( $_SERVER['HTTP_REFERER'] ) ? esc_url_raw( wp_unslash($_SERVER['HTTP_REFERER']) ) : '';

	if ( isset( $_SESSION['previous_url'] ) ) {
		$redirect_to = esc_url_raw( $_SESSION['previous_url'] );
		unset( $_SESSION['previous_url'] );
	}

	return esc_url( $redirect_to );
}

function custom_redirection_after_registration( $redirect_to ) {
	if ( ! session_id() ) {
		session_start();
	}

	$previous_url = isset( $_SERVER['HTTP_REFERER'] ) ? esc_url_raw( wp_unslash($_SERVER['HTTP_REFERER']) ) : '';

	if ( isset( $_SESSION['previous_url'] ) ) {
		$redirect_to = esc_url_raw( $_SESSION['previous_url'] );
		unset( $_SESSION['previous_url'] );
	}
	
	return esc_url( $redirect_to );
}
