<?php

if (!defined('ABSPATH')) {
	exit();
}


if (!class_exists('Adf_Gpby_Product_Detail')) :

	class Adf_Gpby_Product_Detail {
	
		public function __construct() {
			$this->adf_bpby_prodcut_detail_page();
		}

		public function adf_bpby_prodcut_detail_page() {
			add_action('woocommerce_single_product_summary', array( $this, 'adf_gpby_create_group' ), 10);
			add_action('wp_head', array( $this, 'adf_gpby_head_style' ));
		}

		public function adf_gpby_head_style( $getVale ) {
			$getSettingValue = get_option('adf_gpby_general_settings');
			?>
			<style>
				#adf-gpby-add-to-cart {
					background: <?php echo esc_attr($getSettingValue['buy_btn_bg_clr']); ?>;
					color: <?php echo esc_attr($getSettingValue['buy_btn_txt_clr']); ?>;
				}
				#adf-gpby-cr_gp_button {
					background: <?php echo esc_attr($getSettingValue['crt_gp_btn_bg_clr']); ?>;
					color: <?php echo esc_attr($getSettingValue['crt_gp_btn_txt_clr']); ?>;
				}
				.adf-created-customer-msg{
					background: <?php echo esc_attr($getSettingValue['plc_hold_bg_clr']); ?>;
					color: <?php echo esc_attr($getSettingValue['plc_hold_txt_clr']); ?>;
				}
			</style>
			<?php
		}

		public function adf_gpby_create_group() {
			
			global $product;
			
			if ( $product->is_type('variable') || $product->is_type('grouped') ) { 
				return;
			}

			if (!$product->is_in_stock()) {
				return;
			}
			
			$upperHeadingFlag = false;
			$ruleFlag         = false;
			$disableBtn       = false;
			$product_id       = $product->get_id();
			$product_name     = $product->get_name();
			$getProdLink      = get_permalink();
			$user_id          = get_current_user_id();
			$currentnUserRole = $this->get_current_user_role();
			$this->hideCreateButton($product_id, $user_id);

			if (!is_user_logged_in()) {
				$loginUrl = wc_get_page_permalink('myaccount');
			}

			?>
			<div id="adf-gpby-message_custom" class="adf-gpby-message_custom"></div>
			<div id="adf-gpby-message_error_custom" class="adf-gpby-message_error_custom"></div>
			<div id="adf-gpby-overlay" class="adf-gpby-overlay"></div> 
			<?php
		
			$getSettingValue    = get_option('adf_gpby_general_settings');
			$progrssBarSett     = ( isset($getSettingValue['adf_gpby_progrss_bar_pd_det_pg']) ? $getSettingValue['adf_gpby_progrss_bar_pd_det_pg'] : true );
			$timmerSett         = ( isset($getSettingValue['adf_gpby_timmer_enabler_pd_dt']) ? $getSettingValue['adf_gpby_timmer_enabler_pd_dt'] : true );
			$sociallinkSett     = ( isset($getSettingValue['adf_gpby_social_lk_enbl_pd_dtl']) ? $getSettingValue['adf_gpby_social_lk_enbl_pd_dtl'] : true );
			$enableCreatorName  = ( isset($getSettingValue['adf_gpby_creater_name']) ? $getSettingValue['adf_gpby_creater_name'] : true );
			$groupTerms         = ( isset($getSettingValue['adf_gpby_term_condition']) ? $getSettingValue['adf_gpby_term_condition'] : '' );
			$groupDescription   = ( isset($getSettingValue['adf_gpby_term_condition_desc']) ? $getSettingValue['adf_gpby_term_condition_desc'] : '' );
			$counterOption      = ( isset($getSettingValue['adf_gpby_counter_option']) ? $getSettingValue['adf_gpby_counter_option'] : 'counter' );
			$btnLbl             = ( isset($getSettingValue['gp_by_btn_lbl']) ? $getSettingValue['gp_by_btn_lbl'] : 'Group Buy' );
			$crtGrpBtnLbl       = ( isset($getSettingValue['crt_gp_btn_lbl']) ? $getSettingValue['crt_gp_btn_lbl'] : 'Create Group' );
			$createdCustomerMsg = ( isset($getSettingValue['crt_grp_place_holder_txt']) ? $getSettingValue['crt_grp_place_holder_txt'] : '' );

			$enable_rule = get_post_meta($product_id, 'adf_gpby_show_form', true); 
			if (isset($enable_rule) && $enable_rule) :

				$adf_gpby_no_group               = intval(get_post_meta($product_id, 'adf_gpby_no_group', true)); 
				$adf_gpby_private_no_group       = intval(get_post_meta($product_id, 'adf_gpby_private_no_group', true));
				$adf_gpby_allow_public_gp        = get_post_meta($product_id, 'adf_gpby_allow_public_gp', true); 
				$adf_gpby_total_group_member     = intval(get_post_meta($product_id, 'adf_gpby_total_group_member', true));
				$adf_gpby_group_act_no_days      = intval(get_post_meta($product_id, 'adf_gpby_group_act_no_days', true)); 
				$adf_gpby_sin_cus_enb            = get_post_meta($product_id, 'adf_gpby_sin_cus_enb', true);
				$adf_gpby_all_priv_grp           = get_post_meta($product_id, 'adf_gpby_all_priv_grp', true);
				$adf_gpby_strt_date              =  get_post_meta( $product_id, 'adf_gpby_strt_date', true ); 
				$adf_gpby_end_date               =  get_post_meta( $product_id, 'adf_gpby_end_date', true ); 
				$adf_gpby_disc_type              = get_post_meta($product_id, 'adf_gpby_disc_type', true); 
				$adf_gpby_price_type             = get_post_meta($product_id, 'adf_gpby_price_type', true); 
				$adf_gpby_discount_value         = get_post_meta($product_id, 'adf_gpby_discount_value', true);
				$gpby_applied_user_roles         =  get_post_meta( $product_id, 'gpby_applied_user_roles', true );
				$groupCreationUser               = (array) get_post_meta($product_id, 'create_group_user_id_', true);
				$adf_gpby_group_discount_line    = get_post_meta($product_id, 'adf_gpby_group_discount_line', true);
				$adf_discount_groupd_description = get_post_meta($product_id, 'adf_discount_groupd_description', true);
				$current_datetime                = current_datetime()->format('Y-m-d');

				$start_rule_dt  = new DateTime($adf_gpby_strt_date);
				$end_rule_dt    = new DateTime($adf_gpby_end_date);
				$current_dt     = new DateTime($current_datetime);
				$dateInterval   = $start_rule_dt->diff($end_rule_dt);
				$ruleDateDays   = $dateInterval->days;
				$group_id       = $user_id . '_group_' . $product_id;
				$parent_post_id = $product_id;
				$groupInfoCount = $this->getGroupInfoData($product_id, $parent_post_id);

				$regular_price =  $product->get_regular_price();
				$new_price     = $regular_price;
				$sale_price    = $product->get_sale_price();
				$originalPrice = $regular_price;
				

				if ('percent' === $adf_gpby_disc_type) :
					if ('regprice' == $adf_gpby_price_type) :
						$new_price = $regular_price - ( ( $adf_gpby_discount_value/100 ) * $regular_price );
					elseif ('salprice' == $adf_gpby_price_type && !empty($sale_price)) :
						$originalPrice = $product->get_sale_price();
						$new_price     = $sale_price - ( ( $adf_gpby_discount_value/100 ) * $sale_price );
					endif;
				elseif ('fixed' === $adf_gpby_disc_type) :
					if ('regprice' == $adf_gpby_price_type) :
						$new_price = $regular_price - $adf_gpby_discount_value;
					elseif ('salprice' == $adf_gpby_price_type && !empty($sale_price)) :
						$originalPrice = $product->get_sale_price();
						$new_price     = $sale_price - $adf_gpby_discount_value;
					endif;
				endif;

				if (( is_array($gpby_applied_user_roles) && in_array($currentnUserRole, $gpby_applied_user_roles) ) || empty($gpby_applied_user_roles) || 0 === count($gpby_applied_user_roles)) :
						
					if (
						$current_dt >= $start_rule_dt &&
						$current_dt <= $end_rule_dt &&
						(
							( isset($groupInfoCount['noOfpublicGrp']) &&
							'true' == $adf_gpby_allow_public_gp &&
							$groupInfoCount['noOfpublicGrp'] != $adf_gpby_no_group ) ||
							( isset($groupInfoCount['noOfprivateGrp']) &&
							'true' == $adf_gpby_all_priv_grp &&
							$groupInfoCount['noOfprivateGrp'] != $adf_gpby_private_no_group )
						)
					) :

						?>
						<div class="af-gpby-main-conatiner">
							<?php
							if (0 === $user_id) :
								?>
								<div><a href="<?php echo esc_attr($loginUrl); ?>"><p class="button adf-gpby-login-custom-button"> <?php echo esc_html__('Log In to join/create group', 'addify-group-buy-for-woocommerce'); ?></p></a> </div>
								<?php
								return;
							endif;
							if (!( $upperHeadingFlag )) :
								?>
								<div class="adf-gpby-info-group">
									<div><h4><b> <?php echo esc_html__('Group buy', 'addify-group-buy-for-woocommerce'); ?></b></h4></div>
									<div class="adf-gpby-info_icon adf-gpby-hover-text"> 
										<span id="" class="adf-gpby-tooltip-text"> <?php echo wp_kses_post($groupTerms); ?> </span>
										<img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/info.png'); ?>"></img>
									</div>
								</div>
								<div>
									<?php echo wp_kses_post($adf_discount_groupd_description); ?> 
								</div>
								<div class="adf-gpby-heading-discount-div">
									<div class="adf-gpby-heading-discount"><?php echo esc_html__('Group buy price: ', 'addify-group-buy-for-woocommerce'); ?> <?php echo wp_kses_post(WC_price($new_price)); ?>&nbsp;<span class="adf-gpby-orginal_price"><?php echo wp_kses_post(WC_price($originalPrice)); ?></span></div>
								</div>
							<?php
							$upperHeadingFlag = true;
								endif;
							?>
							<div class="adf-gpby-ct-gp-lbl">
								<button id="adf-gpby-cr_gp_button" class="adf-gpby-grp-templete-btn adf-gpby-cr_gp_button alt"> <?php echo esc_html($crtGrpBtnLbl); ?></button>
							</div>
							

							<div class="adf-gpby-form-popup">
								<form class="adf-gpby-form-group">
									<div class="adf-popup-close adf-gpby-cls-icon">&times;</div>
									<h3 style="text-align: center;"><b><?php echo esc_html__('Create Group', 'addify-group-buy-for-woocommerce'); ?></b></h3>
									<div class="adf_private_email_add_msg"></div>
									<div class="adf-gpby-lbl-input">
										<label for="email"><b><?php echo esc_html__('Group Name', 'addify-group-buy-for-woocommerce'); ?></b></label>
										<input class="adf-gpby-gp_nm_inpt" type="text" placeholder="Enter group name" name="adf_db_group_name" required>
									</div>

									<div><b><?php echo esc_html__('Select group type', 'addify-group-buy-for-woocommerce'); ?></b></div>
									<input type="hidden" name="adf_gpby_group_form" value="<?php echo esc_attr(wp_create_nonce('adf_gpby_group_form')); ?>">
									<input type="hidden" name="adf_gpby_no_public_group" value="<?php echo esc_attr($adf_gpby_no_group); ?>">
									<input type="hidden" name="adf_gpby_no_private_group" value="<?php echo esc_attr($adf_gpby_private_no_group); ?>">
									<input type="hidden" name="adf_gpby_product_name" value="<?php echo esc_attr($product_name); ?>">
									<input type="hidden" name="adf_gpby_actic_days" value="<?php echo esc_attr($adf_gpby_group_act_no_days); ?>">
									<input type="hidden" name="adf_curt_prod_id" value="<?php echo esc_attr($product->get_id()); ?>">
									<input type="hidden" name="adf_discount_type" value="<?php echo esc_attr(trim($adf_gpby_disc_type)); ?>">
									<input type="hidden" name="adf_gpby_price_type" value="<?php echo esc_attr(trim($adf_gpby_price_type)); ?>">
									<input type="hidden" name="adf_gpby_disc_price" value="<?php echo esc_attr($adf_gpby_discount_value); ?>">
									<input type="hidden" name="adf_gpby_sin_cus_enb" value="<?php echo esc_attr(trim($adf_gpby_sin_cus_enb)); ?>">
									<input type="hidden" name="adf_gpby_current_post_id" value=" <?php echo esc_attr($product_id); ?>" >
									<input type="hidden" name="adf_gpby_no_allow_memeber_group" value="<?php echo esc_attr($adf_gpby_total_group_member); ?>">
									<input type="hidden" name="adf_gpby_discount_line" value="<?php echo esc_attr($adf_gpby_group_discount_line); ?>">
									<input type="hidden" name="adf_gpby_applied_user_roles" value="
									<?php
									if (is_array($gpby_applied_user_roles)) {
								echo esc_attr(implode('_', $gpby_applied_user_roles));
									} else {
									echo esc_html($gpby_applied_user_roles); }
									?>
									">

									
									<div class="adf-gpby-radio_btn_gp_typ">
										<?php if (isset($groupInfoCount['noOfprivateGrp']) && 'true' == $adf_gpby_all_priv_grp && $groupInfoCount['noOfprivateGrp'] != $adf_gpby_private_no_group) : ?>
											<input type="radio" id="adf-db-private" name="adf_db_group_type" value="private" required>
											<label for="adf-db-private"><?php echo esc_html__('Private', 'addify-group-buy-for-woocommerce'); ?> </label><br>
										<?php endif; ?>

										<?php if (isset($groupInfoCount['noOfpublicGrp']) && 'true' == $adf_gpby_allow_public_gp && $groupInfoCount['noOfpublicGrp'] != $adf_gpby_no_group ) : ?>
											<input type="radio" id="adf-db-public" name="adf_db_group_type" value="public" required>
											<label for="adf-db-public"><?php echo esc_html__('Public', 'addify-group-buy-for-woocommerce'); ?></label><br> 
										<?php endif; ?> 
									</div>

									<div class="adf-gpby-dynm_field_cont">
										<?php if (1 != $adf_gpby_total_group_member) : ?>
											<div id="dynamic-fields-container">
												<?php if ( 'true' == $adf_gpby_sin_cus_enb) : ?>
													<div class="adf-private-help-msg"><?php echo esc_html__('Please add ', 'addify-group-buy-for-woocommerce') . esc_html($adf_gpby_total_group_member-1) . esc_html__(' number of emails to create a private group.', 'addify-group-buy-for-woocommerce'); ?></div>
												<?php else : ?>
													<div class="adf-private-help-msg"><?php echo esc_html__('Invite users by email. If you add fewer than ', 'addify-group-buy-for-woocommerce') . esc_html($adf_gpby_total_group_member-1) . esc_html__(' some members may need to purchase multiple times to complete the group.', 'addify-group-buy-for-woocommerce'); ?></div>
												<?php endif; ?>   
												<input class='adf-gpby-dynamic_field' type="hidden" value="1" id="total_chq">
											</div>
											<button type="button" id="add-field-btn" class="adf-add-field-btn"><?php echo esc_html__('Add Email', 'addify-group-buy-for-woocommerce'); ?></button>
											<button type="button" id="remove-field-btn" class="adf-remove-field-btn"><?php echo esc_html__('Remove', 'addify-group-buy-for-woocommerce'); ?></button>
										<?php endif; ?>  
									</div> 
									<div class="adf-gpby-sv-cls-btns">   
										<button type="submit" class="alt adf-save-gp-btn btn adf-gpby-cls-sv-btn"><?php echo esc_html__('Create', 'addify-group-buy-for-woocommerce'); ?></button>
									</div>
								</form>
							</div>
						</div>
						<?php
						$ruleFlag = true;
					endif;
					wp_reset_postdata();    
				endif;
			endif;
			
			if (false === $ruleFlag) : 
			 
				$terms = get_the_terms( $product_id , 'product_cat' );
				if ( !empty( $terms ) ) {
					foreach ( $terms as $term ) {
						$cat_Id = $term->term_id;
					}
				}
				
				$args  = array(
					'post_type'      => 'addify_gpby',
					'post_status'    => 'publish',
					'posts_per_page' => -1,
					'orderby'        => 'menu_order',
					'order'          => 'ASC',
					'meta_query'     => array(
						array(
							'relation' => 'OR',
							array(
								'key'     => 'gpby_applied_categories',
								'value'   => $cat_Id,
								'compare' => 'LIKE',
							),
							array(
								'key'     => 'gpby_applied_products',
								'value'   => $product_id,
								'compare' => 'LIKE',
							), 
							array(
								'key'     => 'adf_gpby_prod_check',
								'value'   => 'true',
								'compare' => '=',
							),
						),
						array(
							'relation' => 'OR',
							array(
								'key'     => 'gpby_applied_user_roles',
								'value'   => $currentnUserRole,
								'compare' => 'LIKE',
							),
							array(
								'relation' => 'OR', 
								array(
									'key'     => 'gpby_applied_user_roles',
									'compare' => 'NOT EXISTS', 
								),
								array(
									'key'     => 'gpby_applied_user_roles',
									'value'   => '',
									'compare' => '=', 
								),
							),
						),
					),
				);
				$query = new WP_Query($args);
				if ($query->have_posts()) :
					while ($query->have_posts()) :
						$query->the_post();
						$post_id      = get_the_ID();
						$ParentPostId = $post_id;

						$adf_gpby_no_group               =  intval(get_post_meta( $post_id, 'adf_gpby_no_group', true )); 
						$adf_gpby_private_no_group       =  intval(get_post_meta( $post_id, 'adf_gpby_private_no_group', true )); 
						$adf_gpby_allow_public_gp        =  get_post_meta( $post_id, 'adf_gpby_allow_public_gp', true );
						$adf_gpby_all_priv_grp           =  get_post_meta( $post_id, 'adf_gpby_all_priv_grp', true );
						$adf_gpby_sin_cus_enb            = get_post_meta($post_id, 'adf_gpby_sin_cus_enb', true); 
						$adf_gpby_strt_date              =  get_post_meta( $post_id, 'adf_gpby_strt_date', true ); 
						$adf_gpby_end_date               =  get_post_meta( $post_id, 'adf_gpby_end_date', true ); 
						$adf_gpby_disc_type              = get_post_meta($post_id, 'adf_gpby_disc_type', true);
						$adf_gpby_group_act_no_days      = get_post_meta($post_id, 'adf_gpby_group_act_no_days', true); 
						$adf_gpby_total_group_member     = intval(get_post_meta($post_id, 'adf_gpby_total_group_member', true));
						$adf_gpby_discount_value         = get_post_meta($post_id, 'adf_gpby_group_discount_value', true);
						$adf_gpby_price_type             = get_post_meta($post_id, 'adf_gpby_price_type', true); 
						$adf_gpby_group_discount_line    = get_post_meta($post_id, 'adf_gpby_group_discount_line', true); 
						$adf_gpby_applied_user_roles     = get_post_meta($post_id, 'gpby_applied_user_roles', true);
						$adf_discount_groupd_description = get_post_meta($post_id, 'adf_discount_groupd_description', true);

						$current_datetime = current_datetime()->format('Y-m-d');
						$start_rule_dt    = new DateTime($adf_gpby_strt_date);
						$end_rule_dt      = new DateTime($adf_gpby_end_date);
						$current_dt       = new DateTime($current_datetime);
						$dateInterval     = $start_rule_dt->diff($end_rule_dt);
						$ruleDateDays     = $dateInterval->days;
						$group_id         = $user_id . '_group_' . $product_id;
						$parent_post_id   = $post_id;
						$groupInfoCount   = $this->getGroupInfoData($product_id, $parent_post_id);
						
						$regular_price =  $product->get_regular_price();
						$new_price     = $regular_price;
						$sale_price    = $product->get_sale_price();
						$originalPrice = $product->get_regular_price();
						
						if ('percent' === $adf_gpby_disc_type) :
							if ('regprice' == $adf_gpby_price_type) :
								$new_price = $regular_price - ( ( $adf_gpby_discount_value/100 ) * $regular_price );
							elseif ('salprice' == $adf_gpby_price_type && !empty($sale_price)) :
								$originalPrice = $product->get_sale_price();
								$new_price     = $sale_price - ( ( $adf_gpby_discount_value/100 ) * $sale_price );
							endif;
						elseif ('fixed' === $adf_gpby_disc_type) :
							if ('regprice' == $adf_gpby_price_type) :
								$new_price = $regular_price - $adf_gpby_discount_value;
							elseif ('salprice' == $adf_gpby_price_type && !empty($sale_price)) :
								$originalPrice = $product->get_sale_price();
								$new_price     = $sale_price - $adf_gpby_discount_value;
							endif;
						endif;
			
						
						
						if (
							$current_dt >= $start_rule_dt &&
							$current_dt <= $end_rule_dt &&
							(
								( isset($groupInfoCount['noOfpublicGrp']) &&
								'true' == $adf_gpby_allow_public_gp &&
								$groupInfoCount['noOfpublicGrp'] != $adf_gpby_no_group ) ||
								( isset($groupInfoCount['noOfprivateGrp']) &&
								'true' == $adf_gpby_all_priv_grp &&
								$groupInfoCount['noOfprivateGrp'] != $adf_gpby_private_no_group )
							)
						) :
								
							?>
							<div id="adf-gpby-message_custom" class="adf-gpby-message_custom"></div>
							<div id="adf-gpby-message_error_custom" class="adf-gpby-message_error_custom"></div>
						
							<div class="af-gpby-main-conatiner">
								<?php
								if (0 === $user_id) :
									?>
									<div><a href="<?php echo esc_attr($loginUrl); ?>"><p class="button adf-gpby-login-custom-button"> <?php echo esc_html__('Log In to join/create group', 'addify-group-buy-for-woocommerce'); ?></p></a> </div>
									</div>
									<?php
									break;
								endif;
								if (!( $upperHeadingFlag )) :
									?>
								<div class="adf-gpby-info-group">
									<div><h4><b> <?php echo esc_html__('Group buy', 'addify-group-buy-for-woocommerce'); ?></b></h4></div>
									<div class="adf-gpby-info_icon adf-gpby-hover-text"> 
										<span id="" class="adf-gpby-tooltip-text"> <?php echo wp_kses_post($groupTerms); ?> </span>
										<img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/info.png'); ?>"></img>
									</div>
								</div>
								<div>
									<?php echo wp_kses_post($adf_discount_groupd_description); ?> 
								</div>
								<div class="adf-gpby-heading-discount-div">
									<div class="adf-gpby-heading-discount"><?php echo esc_html__('Group buy price: ', 'addify-group-buy-for-woocommerce'); ?> <?php echo wp_kses_post(WC_price($new_price)); ?>&nbsp;<span class="adf-gpby-orginal_price"><?php echo wp_kses_post(WC_price($originalPrice)); ?></span></div>
								</div>
								<?php
								$upperHeadingFlag = true;
									endif;
				
								?>
								<div class="adf-gpby-ct-gp-lbl">
									<button id="adf-gpby-cr_gp_button" class="adf-gpby-grp-templete-btn adf-gpby-cr_gp_button alt"> <?php echo esc_html($crtGrpBtnLbl); ?></button>
								</div>

								<div class="adf-gpby-form-popup">
									<form  class="adf-gpby-form-group">
										<div class="adf-popup-close adf-gpby-cls-icon">&times;</div>
										<h3 style="text-align: center;"><b><?php echo esc_html__('Create Group', 'addify-group-buy-for-woocommerce'); ?></b></h3>
										<div class="adf_private_email_add_msg"></div>
										<div class="adf-gpby-lbl-input">
											<label for="email"><b><?php echo esc_html__('Group Name', 'addify-group-buy-for-woocommerce'); ?></b></label>
											<input class="adf-gpby-gp_nm_inpt" type="text" placeholder="Enter group name" name="adf_db_group_name" required>
										</div>

										<div><b><?php echo esc_html__('Select group type', 'addify-group-buy-for-woocommerce'); ?></b></div>
										<input type="hidden" name="adf_gpby_group_form" value="<?php echo esc_attr(wp_create_nonce('adf_gpby_group_form')); ?>">
										<input type="hidden" name="adf_gpby_no_public_group" value="<?php echo esc_attr($adf_gpby_no_group); ?>">
										<input type="hidden" name="adf_gpby_no_private_group" value="<?php echo esc_attr($adf_gpby_private_no_group); ?>">
										<input type="hidden" name="adf_gpby_product_name" value="<?php echo esc_attr($product_name); ?>">
										<input type="hidden" name="adf_gpby_disc_price" value="<?php echo esc_attr($adf_gpby_discount_value); ?>">
										<input type="hidden" name="adf_gpby_actic_days" value="<?php echo esc_attr($adf_gpby_group_act_no_days); ?>">
										<input type="hidden" name="adf_curt_prod_id" value="<?php echo esc_attr($product->get_id()); ?>">
										<input type="hidden" name="adf_discount_type" value="<?php echo esc_attr(trim($adf_gpby_disc_type)); ?>">
										<input type="hidden" name="adf_gpby_price_type" value="<?php echo esc_attr(trim($adf_gpby_price_type)); ?>">
										<input type="hidden" name="adf_gpby_sin_cus_enb" value="<?php echo esc_attr(trim($adf_gpby_sin_cus_enb)); ?>">
										<input type="hidden" name="adf_gpby_current_post_id" value=" <?php echo esc_attr($post_id); ?>" >
										<input type="hidden" name="adf_gpby_no_allow_memeber_group" value="<?php echo esc_attr($adf_gpby_total_group_member); ?>">
										<input type="hidden" name="adf_gpby_group_descrption" value="<?php echo wp_kses_post($adf_discount_groupd_description); ?>">
										<input type="hidden" name="adf_gpby_discount_line" value="<?php echo esc_attr($adf_gpby_group_discount_line); ?>">
										<input type="hidden" name="adf_gpby_applied_user_roles" value="
										<?php
										if (is_array($adf_gpby_applied_user_roles)) {
echo esc_attr(implode('_', $adf_gpby_applied_user_roles));
										} else {
										echo esc_html($adf_gpby_applied_user_roles); }
										?>
										">
										
										<div class="adf-gpby-radio_btn_gp_typ">
											<?php if (isset($groupInfoCount['noOfprivateGrp']) && 'true' == $adf_gpby_all_priv_grp && $groupInfoCount['noOfprivateGrp'] != $adf_gpby_private_no_group) : ?>
												<input type="radio" id="adf-db-private" name="adf_db_group_type" value="private" required>
												<label for="adf-db-private"><?php echo esc_html__('Private', 'addify-group-buy-for-woocommerce'); ?> </label><br>
											<?php endif; ?>

											<?php if (isset($groupInfoCount['noOfpublicGrp']) && 'true' == $adf_gpby_allow_public_gp && $groupInfoCount['noOfpublicGrp'] != $adf_gpby_no_group ) : ?>
												<input type="radio" id="adf-db-public" name="adf_db_group_type" value="public" required>
												<label for="adf-db-public"><?php echo esc_html__('Public', 'addify-group-buy-for-woocommerce'); ?></label><br> 
											<?php endif; ?> 
										</div>

										<div class="adf-gpby-dynm_field_cont">
											<?php if (1 != $adf_gpby_total_group_member) : ?>
												<div id="dynamic-fields-container">
													<?php if ( 'true' == $adf_gpby_sin_cus_enb) : ?>
														<div class="adf-private-help-msg"><?php echo esc_html__('Please add ', 'addify-group-buy-for-woocommerce') . esc_html($adf_gpby_total_group_member-1) . esc_html__(' number of emails to create a private group.', 'addify-group-buy-for-woocommerce'); ?></div>
													<?php else : ?>
														<div class="adf-private-help-msg"><?php echo esc_html__('Invite users by email. If you add fewer than ', 'addify-group-buy-for-woocommerce') . esc_html($adf_gpby_total_group_member-1) . esc_html__(' some members may need to purchase multiple times to complete the group.', 'addify-group-buy-for-woocommerce'); ?></div>
													<?php endif; ?>   
													<input class='adf-gpby-dynamic_field' type="hidden" value="1" id="total_chq">
												</div>
												<button type="button" id="add-field-btn" class="adf-add-field-btn"><?php echo esc_html__('Add Email', 'addify-group-buy-for-woocommerce'); ?></button>
												<button type="button" id="remove-field-btn" class="adf-remove-field-btn"><?php echo esc_html__('Remove', 'addify-group-buy-for-woocommerce'); ?></button>
											<?php endif; ?>  
										</div> 

										<div class="adf-gpby-sv-cls-btns">   
											<button type="submit" class="alt adf-save-gp-btn btn adf-gpby-cls-sv-btn"><?php echo esc_html__('Create', 'addify-group-buy-for-woocommerce'); ?></button>
										</div>
									</form>
								</div>
							</div>
							<?php
							break;
						endif;
					endwhile;
					wp_reset_postdata();
				endif;
			endif;
					$postIdsArr = array();
	 
					$current_user    = wp_get_current_user();
					$current_user_id = $current_user->ID;

					$particularPost = array(
						'post_type'      => 'addify_gpinfo',
						'author'         => $current_user_id,
						'fields'         => 'ids',
						'post_status'    => 'publish',
						'posts_per_page' => -1,
						'meta_query'     => array(
							array(
								'key'     => 'adf_pgif_product_id',
								'value'   => $product_id,
								'compare' => '=',
							),
							array(
								'relation' => 'OR',
								array(
									'key'     => 'adf_order_showing',
									'value'   => 'true',
									'compare' => '=',
								),
								array(
									'key'     => 'adf_created_group_email',
									'value'   => $current_user->user_email,
									'compare' => '=',
								),
							),
						),
					);

					$query = new WP_Query($particularPost);

					$post_ids   = $query->posts;
					$postIdsArr = $post_ids;
				
					$allPost = array(
						'post_type'      => 'addify_gpinfo',
						'author__not_in' => array( $current_user_id ),
						'fields'         => 'ids',
						'post_status'    => 'publish',
						'posts_per_page' => -1,
						'meta_query'     => array(
							array(
								'key'     => 'adf_pgif_product_id',
								'value'   => $product_id,
								'compare' => '=',
							),
							array(
								'relation' => 'OR',
								array(
									'key'     => 'adf_order_showing',
									'value'   => 'true',
									'compare' => '=',
								),
								array(
									'key'     => 'adf_created_group_email',
									'value'   => $current_user->user_email,
									'compare' => '=',
								),
							),
						),
					);

					$query = new WP_Query($allPost);

					$post_ids   = $query->posts;
					$postIdsArr = array_merge($postIdsArr, $post_ids);
			
					$args = array(
						'post_type'      => 'addify_gpinfo',
						'posts_per_page' => -1,
						'post_status'    => 'publish',
						'meta_query'     => array(
							array(
								'key'     => 'adf_pgif_product_id',
								'value'   => $product_id,
								'compare' => '=',
							),
							array(
								'relation' => 'OR',
								array(
									'key'     => 'adf_order_showing',
									'value'   => 'true',
									'compare' => '=',
								),
								array(
									'key'     => 'adf_created_group_email',
									'value'   => $current_user->user_email,
									'compare' => '=',
								),
							),
						),
					);

					$query = new WP_Query($args);               
					if ($query->have_posts()) :

						$index               = 0; 
						$getNumberOfcustomer = 0;
						$showGroupflag       = false; 
						$showPopup           = false;
						$disableGroupMore    = false;
						?>
						<div>
							<?php
							
							foreach ($postIdsArr as $post_id) :
								
								if (0 === $user_id) :
									break;
								endif;
								
								++$index;
								
								$groupInfoStatus = 'processing';
							
								$allowUserRole                = get_post_meta($post_id, 'adf_gpif_applied_user_roles', true);
								$groupType                    = get_post_meta($post_id, 'adf_pgif_group_type', true);
								$groupName                    = get_post_meta($post_id, 'adf_pgif_group_name', true);
								$endGroupTime                 = get_post_meta($post_id, 'adf_pgif_group_exprire', true);
								$authurName                   = get_post_meta($post_id, 'adf_pgif_group_auth', true);
								$groupJoingMember             = get_post_meta($post_id, 'adf_pgif_join_group_member_info', true);
								$groupInfoStatus              = get_post_meta( $post_id, 'adf_gpby_group_info_status', true);
								$allowEmail                   = get_post_meta($post_id, 'adf_gpby_group_allow_users', true);
								$getNumberOfcustomer          = intval(get_post_meta($post_id, 'adf_pgif_group_join_memeber', true));
								$group_id                     = get_post_meta($post_id, 'adf_pgif_group_id', true);
								$discpuntPrice                = get_post_meta($post_id, 'adf_pgif_group_price', true);
								$groupDescription             = get_post_meta($post_id, 'adf_gpif_group_desc', true);
								$createdGroupUsers            = get_post_meta($post_id, 'adf_pgif_user_id', true);
								$adf_gpif_group_member        = intval(get_post_meta($post_id, 'adf_gpif_group_member', true));
								$adf_gpby_group_discount_line = get_post_meta($post_id, 'adf_gpif_discount_line', true);
								
								$group_create_num = $group_id;
								$end_group_time   = new DateTime($endGroupTime);
								$current_date     = new DateTime($current_datetime);
								$currentTime      = new DateTime();
								
								if ('qualified' == $groupInfoStatus || 'disqualified' == $groupInfoStatus) :
									continue;
								endif;

								if (( $end_group_time <= $current_date )) :
									update_post_meta($post_id, 'adf_gpby_group_info_status', 'disqualified');
									
									$groupInfoDatas = get_post_meta($post_id, 'adf_pgif_join_group_member_info', true);

									if (is_array($groupInfoDatas)) :
										foreach ($groupInfoDatas as $groupInfoData) :
											$email[]          = $this->getEmailById($groupInfoData[4]);
											$productPermalink = $this->getProductParmlink($groupInfoData[6]);
										endforeach;

										$this->sendDisqualifyEmail($email, $productPermalink, $groupName);
									endif;
									continue;
								endif;
							
								if (isset($getNumberOfcustomer)) :
									if ($adf_gpif_group_member == $getNumberOfcustomer) :
										
										update_post_meta( $post_id, 'adf_gpby_group_info_status', 'qualified');
									
										$disableBtn = true;

										$groupInfoDatas = get_post_meta($post_id, 'adf_pgif_join_group_member_info', true);
										if (is_array($groupInfoDatas)) :
											foreach ($groupInfoDatas as $groupInfoData) :
												$email[]          = $this->getEmailById($groupInfoData[4]);
												$productPermalink = $this->getProductParmlink($groupInfoData[6]);
												
											endforeach;

											$this->sendEmail($email, $productPermalink, $groupName);
										endif;
									endif;
								else :
									$getNumberOfcustomer = 0;
								endif;
								
								if (0 === $getNumberOfcustomer) :
									?>
									<div class="adf-created-customer-msg"> <?php echo esc_html($createdCustomerMsg); ?></div>
									<?php
								endif;
								
								if (false === $showGroupflag) :
									
									if ('private' === $groupType) :
										
										$current_user = wp_get_current_user();
										
										if (is_array($allowEmail)) :
											if (in_array($current_user->user_email, $allowEmail)) :
												?>
												<div class="adf-gbpby-main_group_container adf-gpby-group-container-main">
													<div class="adf-gpby-group-first-row">
														<div id="adf-gpby-group_name" class="adf-gpby-row-label"><?php echo esc_html($groupName) . ':'; ?></div>
														<div><?php echo esc_html(str_replace('{discount_value}', intval($discpuntPrice), $adf_gpby_group_discount_line)); ?></div>
													</div>
													
													<?php if ('true' === $enableCreatorName) : ?>
														
														<div id="" class="adf-gpby-group-row">
															<div class="adf-gpby-row-label"> <?php echo esc_html__('Creator: ', 'addify-group-buy-for-woocommerce'); ?> </div>
															<div> <?php echo esc_html($authurName); ?></div>
														</div>
													<?php endif; ?> 

													<div class="adf-gpby-group-row-exp">
														<div class="adf-gpby-row-expiry-lbl"><div class="adf-gpby-row-label"> <?php echo esc_html__('Expires in: ', 'addify-group-buy-for-woocommerce'); ?> </div></div>
														<?php if ('counter' === $counterOption) : ?>
															<span class="adf-gpby_counter" data-end-time="<?php echo esc_attr($endGroupTime); ?>"></span>
															<div id="flipdown" class="flipdown"></div>
														<?php else : ?>
															<!-- second timmer -->
															<div id="adf-gpby-text-countdown">
																<span class="adf-gpby_counter_second" data-end-time="<?php echo esc_attr($endGroupTime); ?>"></span>
																<span id="days" class="adf-gpby-text-countdown-dig"></span> <?php echo esc_html__('days,', 'addify-group-buy-for-woocommerce') ; ?> 
																<span id="hours" class="adf-gpby-text-countdown-dig"></span> <?php echo esc_html__('hours,', 'addify-group-buy-for-woocommerce') ; ?> 
																<span id="minutes" class="adf-gpby-text-countdown-dig"></span> <?php echo esc_html__('minutes', 'addify-group-buy-for-woocommerce') ; ?>  
															</div>
														<?php endif; ?>
													</div>

													<div class="adf-gpby-group-row-progress">
														<div class="adf-gpby-row-label adf-gpby-prgress-label" >  <?php echo esc_html__('Progress: ', 'addify-group-buy-for-woocommerce'); ?> </div>
														
														<div class="adf-gpby-prg-bar-mian-con">
															<div class="adf-gpby-join-memeber"><?php echo esc_html($getNumberOfcustomer); ?> <?php echo esc_html__('join', 'addify-group-buy-for-woocommerce'); ?></div>
															<div id="adf-gpby-myProgress"><div class="adf-progress-bar" id="adf-progress-bar"></div></div>
															<div class="adf-gpby-left-memeber"><?php echo esc_html($adf_gpif_group_member - $getNumberOfcustomer) . esc_html__(' left', 'addify-group-buy-for-woocommerce'); ?></div>
														</div>
													</div>
													<div class="adf-gpby-group-footer-cont">
													
														<div class="adf-gpby-other-groups-div"><p class="adf-gpby-join-custom-button adf-gpby-other-group" data-value="<?php echo esc_attr($product_id); ?>"><?php echo esc_html__('Other groups', 'addify-group-buy-for-woocommerce'); ?></p></div>
														<div>   
															<form class="form-ofgroup-container">
																	<input type="hidden" name="adf_gpby_group_form" value="<?php echo esc_html(wp_create_nonce('adf_gpby_group_form', 'addify-group-buy-for-woocommerce')); ?>">
																	<input id="adf-gpby-single-cus-enable" class="adf-gpby-single-cus-enable" type="hidden" name="adf_gpby_sing_cust_enable" value=" <?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" >
																	<input id="adf-group-number" class="adf-group-number" type="hidden" name="adf_group_number" value=" <?php echo esc_attr($group_create_num); ?>" >
																	<input id="adf-timer-end-rule" class="adf-timer-end-rule" type="hidden" name="adf_end_date_time" value=" <?php echo esc_attr($endGroupTime); ?>" >
																	<input id="adf-gpby-group-id" class="adf-gpby-group-id" type="hidden" name="adf_gpby_group_id" value=" <?php echo esc_attr($group_id); ?>" >
																	<input id="adf-tol-num-member" class="adf-tol-num-member" type="hidden" name="adf_tol_num_member" value=" <?php echo esc_attr($adf_gpif_group_member); ?>" >
																	<input id="adf-purchase-member" class="adf-purchase-member" type="hidden" name="adf_purcahse_num_member" value=" 
																	<?php
																	if (isset($getNumberOfcustomer)) {
																		echo esc_attr($getNumberOfcustomer);}
																	?>
																	" >
																	<input id="adf-gpby_product_Id" class="adf-gpby_product_Id" type="hidden" name="adf_product_Id" value=" <?php echo esc_attr($product->get_id()); ?>" >
																	<input id="adf-gpby_product_Id" class="adf-gpby_product_Id" type="hidden" name="adf_single_customer_en" value=" <?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" >
																<button name="" class="adf-gpby-grp-templete-btn adf-gpby-add-to-cart alt" id="adf-gpby-add-to-cart" 
																	<?php
																	if (true === $disableBtn) {
																			echo esc_attr('disabled');}
																	?>
																	> <?php echo esc_html($btnLbl); ?>
																</button>
															</form>
														</div>
														<div class="adf-gpby-group-social-cont">
															<div id="adf-gpby-social_btn_<?php echo esc_attr($index); ?>" class="adf-gpby-social_btn adf-gpby-grp-templete-btn" data-target="#adf-gpby-social_link_popup_id_<?php echo esc_html($index); ?>"><img src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/share_icon.png'); ?>"></img></div>
															<div id="adf-gpby-social_link_popup_id_<?php echo esc_attr($index); ?>" class="adf-gpby-social_link_popup">
																<a href="https://twitter.com/intent/tweet?url=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/twitter.png'); ?>" alt="Socail icon"></a>
																<a href="http://www.facebook.com/sharer/sharer.php?u=<?php echo esc_attr($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/fb.png'); ?>" alt="Socail icon"></a>
																<a href="https://www.linkedin.com/sharing/share-offsite/?url=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/linkedin.png'); ?>" alt="Socail icon"></a>
																<a href="mailto:?subject=Check this out&body=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/emial.png'); ?>" alt="Socail icon"></a>
															</div>
														</div>
													</div>
												</div>
												<?php
												$showGroupflag = true; 
											endif;
										endif;
									elseif ('public' === $groupType && ( empty($allowUserRole) || in_array($currentnUserRole, $allowUserRole) )) :  
										?>
										<div class="adf-gbpby-main_group_container adf-gpby-group-container-main">
											<div class="adf-gpby-group-first-row">
												<div id="adf-gpby-group_name" class="adf-gpby-row-label"><?php echo esc_html($groupName) . ':'; ?></div>
												<div><?php echo esc_html(str_replace('{discount_value}', intval($discpuntPrice), $adf_gpby_group_discount_line)); ?></div>
											</div>
											<?php if ('true' === $enableCreatorName) : ?>
												<div id="" class="adf-gpby-group-row">
													<div class="adf-gpby-row-label"> <?php echo esc_html__('Creator: ', 'addify-group-buy-for-woocommerce'); ?> </div>
													<div> <?php echo esc_html($authurName); ?></div>
												</div>
											<?php endif; ?>
											<div class="adf-gpby-group-row-exp">
												<div class="adf-gpby-row-expiry-lbl"><div class="adf-gpby-row-label"> <?php echo esc_html__('Expires in: ', 'addify-group-buy-for-woocommerce'); ?> </div></div>
														<?php if ('counter' === $counterOption) : ?>
													<span class="adf-gpby_counter" data-end-time="<?php echo esc_attr($endGroupTime); ?>"></span>
													<div id="flipdown" class="flipdown"></div>
												<?php else : ?>
													<!-- second timmer -->
													<div id="adf-gpby-text-countdown">
														<span class="adf-gpby_counter_second" data-end-time="<?php echo esc_attr($endGroupTime); ?>"></span>
														<span id="days" class="adf-gpby-text-countdown-dig"></span> <?php echo esc_html__('days,', 'addify-group-buy-for-woocommerce') ; ?> 
														<span id="hours" class="adf-gpby-text-countdown-dig"></span> <?php echo esc_html__('hours,', 'addify-group-buy-for-woocommerce') ; ?> 
														<span id="minutes" class="adf-gpby-text-countdown-dig"></span> <?php echo esc_html__('minutes', 'addify-group-buy-for-woocommerce') ; ?>  
													</div>
												<?php endif; ?>
											</div>

											<div class="adf-gpby-group-row-progress">
												<div class="adf-gpby-row-label adf-gpby-prgress-label" >  <?php echo esc_html__('Progress: ', 'addify-group-buy-for-woocommerce'); ?> </div>
												
												<div class="adf-gpby-prg-bar-mian-con">
													<div class="adf-gpby-join-memeber"><?php echo esc_html($getNumberOfcustomer); ?> <?php echo esc_html__('join', 'addify-group-buy-for-woocommerce'); ?></div>
													<div id="adf-gpby-myProgress"><div class="adf-progress-bar" id="adf-progress-bar"></div></div>
													<div class="adf-gpby-left-memeber"><?php echo esc_html($adf_gpif_group_member - $getNumberOfcustomer) . esc_html__(' left', 'addify-group-buy-for-woocommerce'); ?></div>
												</div>
											</div>
											<div class="adf-gpby-group-footer-cont">
												
												<div class="adf-gpby-other-groups-div"><p class="adf-gpby-join-custom-button adf-gpby-other-group" data-value="<?php echo esc_attr($product_id); ?>"><?php echo esc_html__('Other groups', 'addify-group-buy-for-woocommerce'); ?></p></div>
												
												<div>   
													<form class="form-ofgroup-container">
															<input type="hidden" name="adf_gpby_group_form" value="<?php echo esc_html(wp_create_nonce('adf_gpby_group_form', 'addify-group-buy-for-woocommerce')); ?>">
															<input id="adf-gpby-single-cus-enable" class="adf-gpby-single-cus-enable" type="hidden" name="adf_gpby_sing_cust_enable" value=" <?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" >
															<input id="adf-group-number" class="adf-group-number" type="hidden" name="adf_group_number" value=" <?php echo esc_attr($group_create_num); ?>" >
															<input id="adf-timer-end-rule" class="adf-timer-end-rule" type="hidden" name="adf_end_date_time" value=" <?php echo esc_attr($endGroupTime); ?>" >
															<input id="adf-gpby-group-id" class="adf-gpby-group-id" type="hidden" name="adf_gpby_group_id" value=" <?php echo esc_attr($group_id); ?>" >
															<input id="adf-tol-num-member" class="adf-tol-num-member" type="hidden" name="adf_tol_num_member" value=" <?php echo esc_attr($adf_gpif_group_member); ?>" >
															<input id="adf-purchase-member" class="adf-purchase-member" type="hidden" name="adf_purcahse_num_member" value=" 
															<?php
															if (isset($getNumberOfcustomer)) {
																echo esc_attr($getNumberOfcustomer);}
															?>
															" >
															<input id="adf-gpby_product_Id" class="adf-gpby_product_Id" type="hidden" name="adf_product_Id" value=" <?php echo esc_attr($product->get_id()); ?>" >
															<input id="adf-gpby_product_Id" class="adf-gpby_product_Id" type="hidden" name="adf_single_customer_en" value=" <?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" >
														<button name= "adf_gpby_click_btn" class="adf-gpby-grp-templete-btn adf-gpby-add-to-cart alt" id="adf-gpby-add-to-cart" 
															<?php
															if (true === $disableBtn) {
																echo esc_attr('disabled');}
															?>
															> <?php echo esc_html($btnLbl); ?>
														</button>
													</form>
												</div>
												<div class="adf-gpby-group-social-cont">
													<div id="adf-gpby-social_btn_<?php echo esc_attr($index); ?>" class="adf-gpby-social_btn adf-gpby-grp-templete-btn" data-target="#adf-gpby-social_link_popup_id_<?php echo esc_html($index); ?>"><img src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/share_icon.png'); ?>"></img></div>
													<div id="adf-gpby-social_link_popup_id_<?php echo esc_attr($index); ?>" class="adf-gpby-social_link_popup">
														<a href="https://twitter.com/intent/tweet?url=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/twitter.png'); ?>" alt="Socail icon"></a>
														<a href="http://www.facebook.com/sharer/sharer.php?u=<?php echo esc_attr($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/fb.png'); ?>" alt="Socail icon"></a>
														<a href="https://www.linkedin.com/sharing/share-offsite/?url=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/linkedin.png'); ?>" alt="Socail icon"></a>
														<a href="mailto:?subject=Check this out&body=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/emial.png'); ?>" alt="Socail icon"></a>
													</div>
												</div>
											</div>
										</div>
										<?php
										$showGroupflag = true; 
									endif;
								elseif (true == $showGroupflag) :
									
									if (false == $showPopup) :
										?>
										
										<input id="adf-gpby-disable-more-grp" type="hidden" name="adf_gpby_disable_more_grp" value="hide_more_group_btn">
										<!-- showing group on the pop up  -->
										<div class="adf-gpby-created-grup_container adf-groups-prod-<?php echo esc_attr($product_id); ?>">
										<div class="adf-gpby-close-form-shp-pg adf-gpby-cls-icon">&times;</div> 
										<?php

									endif;
	
									if ('public' === $groupType && ( empty($allowUserRole) || in_array($currentnUserRole, $allowUserRole) )) : 
										?>
										<div class="adf-gpby-group-container-main">
											<form class="form-ofgroup-container">
												<div>
													<input type="hidden" name="adf_gpby_group_form" value="<?php echo esc_html(wp_create_nonce('adf_gpby_group_form')); ?>">
													<input id="adf-gpby-single-cus-enable" class="adf-gpby-single-cus-enable" type="hidden" name="adf_gpby_sing_cust_enable" value=" <?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" >
													<input id="adf-group-number" class="adf-group-number" type="hidden" name="adf_group_number" value=" <?php echo esc_attr($group_create_num); ?>" >
													<input id="adf-timer-end-rule" class="adf-timer-end-rule" type="hidden" name="adf_end_date_time" value=" <?php echo esc_attr($endGroupTime); ?>" >
													<input id="adf-gpby-group-id" class="adf-gpby-group-id" type="hidden" name="adf_gpby_group_id" value=" <?php echo esc_attr($group_id); ?>" >
													<input id="adf-tol-num-member" class="adf-tol-num-member" type="hidden" name="adf_tol_num_member" value=" <?php echo esc_attr($adf_gpif_group_member); ?>" >
													<input id="adf-purchase-member" class="adf-purchase-member" type="hidden" name="adf_purcahse_num_member" value=" 
													<?php
													if (isset($getNumberOfcustomer)) {
														echo esc_attr($getNumberOfcustomer);}
													?>
													" >
													<input id="adf-gpby_product_Id" class="adf-gpby_product_Id" type="hidden" name="adf_product_Id" value=" <?php echo esc_attr($product->get_id()); ?>" >
													<input id="adf-gpby_product_Id" class="adf-gpby_product_Id" type="hidden" name="adf_single_customer_en" value=" <?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" >
													<div class="adf-gpby-pg_bar_gp_btn_shp_pg">
														<div class="adf-gpby-sh-pg-group-info">
															<div class="adf-gpby-group_name"><?php echo esc_html($groupName); ?></div>
															<?php if ('true' === $enableCreatorName) : ?>
																<div><?php echo esc_html__('Created by: ', 'addify-group-buy-for-woocommerce'); ?><?php echo esc_html($authurName); ?></div>
															<?php endif; ?>
															<span><?php echo esc_html__('Group Expires in:', 'addify-group-buy-for-woocommerce'); ?></span>
															<span class="adf-gpby_timmer" data-end-time="<?php echo esc_attr($endGroupTime); ?>"></span>
															<div>
															<?php
															echo esc_html(intval($adf_gpif_group_member) - $getNumberOfcustomer);
															echo esc_html__(' Membere Remianing to claim this Deal', 'addify-group-buy-for-woocommerce');
															?>
															</div>
															<div id="adf-gpby-myProgress">
																<div class="adf-progress-bar" id="adf-progress-bar"></div>
															</div>
														</div>  
														<div class="adf-gpby-gpbuy-share-btns">  
															<div><button class="adf-gpby-add-to-cart adf-gpby-btn-popup" data-product-id= "<?php echo esc_attr($product->get_id()); ?>" data-group-id="<?php echo esc_attr($group_id); ?>" data-group-num="<?php echo esc_attr($group_create_num); ?>" data-sing-cust-enable="<?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" 
																																						<?php
																																						if (true === $disableBtn) {
																										echo 'disabled';}
																																						?>
															> <?php echo esc_html__('Group Buying', 'addify-group-buy-for-woocommerce'); ?></button></div> 
															<div class="adf-gpby-social_con_in_popup">
																<div id="adf-gpby-social_btn_<?php echo esc_attr($index); ?>" class="adf-gpby-social_btn" data-target="#adf-gpby-social_link_popup_id_<?php echo esc_attr($index); ?>"><?php echo esc_html__('Share Group', 'addify-group-buy-for-woocommerce'); ?></div>
																<div id="adf-gpby-social_link_popup_id_<?php echo esc_attr($index); ?>" class="adf-gpby-social_link_popup">
																	<a href="https://twitter.com/intent/tweet?url=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/twitter.png'); ?>" alt="Socail icon"></a>
																	<a href="http://www.facebook.com/sharer/sharer.php?u=<?php echo esc_attr($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/fb.png'); ?>" alt="Socail icon"></a>
																	<a href="https://www.linkedin.com/sharing/share-offsite/?url=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/linkedin.png'); ?>" alt="Socail icon"></a>
																	<a href="mailto:?subject=Check this out&body=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/emial.png'); ?>" alt="Socail icon"></a>
																</div>
															</div>
														</div>
													</div>
												</div>
											</form>
										</div>
										<?php  
										 
									elseif ('private' === $groupType) : 
										
										$current_user = wp_get_current_user();
										
										if (is_array($allowEmail)) :
											
											if (in_array($current_user->user_email, $allowEmail)) :
												?>
												<div class="adf-gpby-group-container-main">
													<form class="form-ofgroup-container">
														<div>
															<div>
																<input type="hidden" name="adf_gpby_group_form" value="<?php echo esc_html(wp_create_nonce('adf_gpby_group_form')); ?>">
																<input id="adf-gpby-single-cus-enable" class="adf-gpby-single-cus-enable" type="hidden" name="adf_gpby_sing_cust_enable" value=" <?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" >
																<input id="adf-group-number" class="adf-group-number" type="hidden" name="adf_group_number" value=" <?php echo esc_attr($group_create_num); ?>" >
																<input id="adf-timer-end-rule" class="adf-timer-end-rule" type="hidden" name="adf_end_date_time" value=" <?php echo esc_attr($endGroupTime); ?>" >
																<input id="adf-gpby-group-id" class="adf-gpby-group-id" type="hidden" name="adf_gpby_group_id" value=" <?php echo esc_attr($group_id); ?>" >
																<input id="adf-tol-num-member" class="adf-tol-num-member" type="hidden" name="adf_tol_num_member" value=" <?php echo esc_attr($adf_gpif_group_member); ?>" >
																<input id="adf-purchase-member" class="adf-purchase-member" type="hidden" name="adf_purcahse_num_member" value=" 
																<?php
																if (isset($getNumberOfcustomer)) {
																	echo esc_attr($getNumberOfcustomer);}
																?>
																" >
																<input id="adf-gpby_product_Id" class="adf-gpby_product_Id" type="hidden" name="adf_product_Id" value=" <?php echo esc_attr($product->get_id()); ?>" >
																<input id="adf-gpby_product_Id" class="adf-gpby_product_Id" type="hidden" name="adf_single_customer_en" value=" <?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" >
																<div class="adf-gpby-pg_bar_gp_btn_shp_pg">
																	<div class="adf-gpby-sh-pg-group-info">
																		<div class="adf-gpby-group_name"><?php echo esc_html($groupName); ?></div>
																		<?php if ('true' === $enableCreatorName) : ?>
																			<div><?php echo esc_html__('Created by: ', 'addify-group-buy-for-woocommerce'); ?><?php echo esc_html($authurName); ?></div>
																		<?php endif; ?>
																		<span><?php echo esc_html__('Group Expires in:', 'addify-group-buy-for-woocommerce'); ?></span>
																		<span class="adf-gpby_timmer" data-end-time="<?php echo esc_attr($endGroupTime); ?>"></span>
																		<div>
																		<?php
																		echo esc_html(intval($adf_gpif_group_member) - $getNumberOfcustomer);
																			echo esc_html__(' Membere Remianing to claim this Deal', 'addify-group-buy-for-woocommerce');
																		?>
																		</div>
																		<div id="adf-gpby-myProgress">
																			<div class="adf-progress-bar" id="adf-progress-bar"></div>
																		</div>
																	</div>  
																	<div class="adf-gpby-gpbuy-share-btns">  
																		<div><button class="adf-gpby-add-to-cart adf-gpby-btn-popup" data-product-id= "<?php echo esc_attr($product->get_id()); ?>" data-group-id="<?php echo esc_attr($group_id); ?>" data-group-num="<?php echo esc_attr($group_create_num); ?>" data-sing-cust-enable="<?php echo esc_attr($adf_gpby_sin_cus_enb); ?>" 
																																								<?php
																																								if (true === $disableBtn) {
																									echo 'disabled';}
																																								?>
																		> <?php echo esc_html__('Group Buying', 'addify-group-buy-for-woocommerce'); ?></button></div> 
																		<div calss="adf-gpby-social_con_in_popup">
																			<div id="adf-gpby-social_btn_<?php echo esc_attr($index); ?>" class="adf-gpby-social_btn" data-target="#adf-gpby-social_link_popup_id_<?php echo esc_attr($index); ?>"><?php echo esc_html__('Share Group', 'addify-group-buy-for-woocommerce'); ?></div>
																			<div id="adf-gpby-social_link_popup_id_<?php echo esc_attr($index); ?>" class="adf-gpby-social_link_popup">
																				<a href="https://twitter.com/intent/tweet?url=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/twitter.png'); ?>" alt="Socail icon"></a>
																				<a href="http://www.facebook.com/sharer/sharer.php?u=<?php echo esc_attr($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/fb.png'); ?>" alt="Socail icon"></a>
																				<a href="https://www.linkedin.com/sharing/share-offsite/?url=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/linkedin.png'); ?>" alt="Socail icon"></a>
																				<a href="mailto:?subject=Check this out&body=<?php echo urlencode($getProdLink); ?>" target="_blank"><img class="adf-gpby-social-icon" src="<?php echo esc_attr(AF_GPBY_URL . 'assets/upload/emial.png'); ?>" alt="Socail icon"></a>
																			</div>
																		</div>
																	</div>
																</div>
															</div>
														</div>
													</form>
												</div>
												<?php
											else :
												
												?>
												<div class="adf_private_not_shown_msg"> <?php echo esc_html__('No group have been created against this product yet. Create a group now and invite members to claim the group buying discount.', 'addify-group-buy-for-woocommerce'); ?></div>
												<div id="adf_cancel_popup_btn"><button class="adf-gpby-close-form-shp-pg alt"><?php echo esc_html('Cancel'); ?></button></div>
																																		<?php
												
											endif;
										endif;  
									endif;
									$showPopup = true;
								endif;
								
							endforeach;
							if (true == $showPopup) :
								?>
							</div>
							<?php endif; ?>
						</div>
						<?php
						wp_reset_postdata();
					endif;
		}

		public function get_current_user_role() {
			global $wp_roles;
			if ( is_user_logged_in() ) {
			$user  = wp_get_current_user();
			$roles = ( array ) $user->roles;
			$role  = $roles[0];
			return $role;
			} else {
			return 'guest';
			}
		}

		public function getGroupInfoData( $product_id, $parent_post_id ) {
			$totalNoOfGrp   = array(
				'noOfpublicGrp'  => 0,
				'noOfprivateGrp' => 0,
			);
			$noOfpublicGrp  = 0;
			$noOfprivateGrp = 0;
			$args           = array(
				'post_type'      => 'addify_gpinfo',
				'posts_per_page' => -1,
				'post_status'    => 'publish',
				'post_parent'    => $parent_post_id,
				'meta_query'     => array(
					array(
						'key'     => 'adf_pgif_product_id',
						'value'   => $product_id,
						'compare' => '=',
					),
				),
			);

			$query = new WP_Query($args);
			if ($query->have_posts()) {
				while ($query->have_posts()) :
					$query->the_post();
					$post_id = get_the_ID();

					$groupType = get_post_meta($post_id, 'adf_pgif_group_type', true);
					if ('public' === $groupType) :
						++$noOfpublicGrp;
					elseif ('private' === $groupType) :
						++$noOfprivateGrp;
					endif;
				endwhile;
				$totalNoOfGrp = array(
					'noOfpublicGrp'  => $noOfpublicGrp,
					'noOfprivateGrp' => $noOfprivateGrp,
				);
			}
		   
		return $totalNoOfGrp;
		}

		public function sendEmail( $emails, $productLinks, $groupName ) {

			array_push($emails, get_option('admin_email'));

			$new_form_data = array(
				'product_url' => esc_url($productLinks),
				'group_title' => esc_html($groupName),
				'emails'      => $emails,
			);

			WC()->mailer()->emails['Adf_Gpby_Qualified_Group_Email']->trigger($new_form_data );
		}

		public function sendDisqualifyEmail( $emails, $productLinks, $groupName ) {

			array_push($emails, get_option('admin_email'));
			
			$new_form_data = array(
				'product_url' => esc_url($productLinks),
				'group_title' => esc_html($groupName),
				'emails'      => $emails,
			);

			WC()->mailer()->emails['Adf_Gpby_Disqualified_Group_Email']->trigger($new_form_data );
		}
		

		public function getEmailById( $id ) {
			$current_user_data = get_userdata($id);
			$user_email        = $current_user_data->user_email;
			return $user_email;
		}

		public function getProductParmlink( $id ) {
			$link = get_permalink( $id );
			return $link;
		}

		
		public function hideCreateButton( $post_id, $user_id ) {

			$args = array(
				'post_type'      => 'addify_gpinfo',
				'posts_per_page' => -1,
				'post_status'    => 'publish',
				'meta_query'     => array(
					'relation' => 'AND',
					array(
						'key'     => 'adf_pgif_product_id',
						'value'   => $post_id,
						'compare' => '=',
					),
					array(
						'key'     => 'adf_pgif_user_id',
						'value'   => $user_id,
						'compare' => '=',
					),
		
					array(
						'key'     => 'adf_gpby_group_info_status',
						'value'   => 'processing',
						'compare' => '=',
					),
				),
			);
			$query = new WP_Query($args);
				 
			if ($query->have_posts()) :
				?>
				<input class="adf-pps-create-btn-hdn" type="hidden" name="adf_pps_create_btn_hdn" value="adf_pps_create_btn_hdn">
				<?php
			endif;
		}
	}
	new Adf_Gpby_Product_Detail();
endif;