<?php

if (!defined('ABSPATH')) {
	exit();
}

if (!class_exists('Addify_Group_Buying_Main')) :
	class Addify_Group_Buying_Main {

		public function __construct() {
			add_action('init', array( $this, 'check_woocommerce_is_defined_or_not' ));
		}

		public function check_woocommerce_is_defined_or_not() { 
			
			if (defined('WC_PLUGIN_FILE')) {

				$this->include_files();
				$this->register_post_types();
				add_filter('woocommerce_email_classes', array( $this, 'adf_gpby_email_register' ), 90, 1);
				add_filter( 'woocommerce_order_item_get_formatted_meta_data', array( $this, 'adf_gpby_hide_buygroupid_meta_data' ), 10, 2 );
				
			}
		}
			
		public function include_files() {
			if ( is_admin() ) { 
				include_once AF_GPBY_DIR . 'includes/admin/addify-gpby-meta-box.php';
			} else {
				include_once AF_GPBY_DIR . 'includes/front/adf_gpby_front.php';
			}
		
			include_once AF_GPBY_DIR . 'includes/ajax-function.php';
		}

	
		public function register_post_types() {
			
			$labels = array(
				'name'                => __('Group Buying', 'addify-group-buy-for-woocommerce'),
				'singular_name'       => __('Group Buying', 'addify-group-buy-for-woocommerce'),
				'add_new'             => __('Add New Rule', 'addify-group-buy-for-woocommerce'),
				'add_new_item'        => __('Add Rule', 'addify-group-buy-for-woocommerce'),
				'edit_item'           => __('Edit Rule', 'addify-group-buy-for-woocommerce'),
				'new_item'            => __('New Rule', 'addify-group-buy-for-woocommerce'),
				'view_item'           => __('View Rule', 'addify-group-buy-for-woocommerce'),
				'search_items'        => __('Search Rule', 'addify-group-buy-for-woocommerce'),
				'exclude_from_search' => true,
				'not_found'           => __('No rule found', 'addify-group-buy-for-woocommerce'),
				'not_found_in_trash'  => __('No rule found in trash', 'addify-group-buy-for-woocommerce'),
				'parent_item_colon'   => '',
				'all_items'           => __('Group Buying', 'addify-group-buy-for-woocommerce'),
				'menu_name'           => __('Group Buying', 'addify-group-buy-for-woocommerce'),
			);
	
			$args = array(
				'labels'             => $labels,
				'public'             => false,
				'publicly_queryable' => false,
				'show_ui'            => true,
				'show_in_menu'       => 'woocommerce',
				'query_var'          => true,
				'capability_type'    => 'post',
				'has_archive'        => true,
				'hierarchical'       => true,
				'menu_position'      => 50,
				'rewrite'            => array(
					'slug'       => 'addify_gpby',
					'with_front' => false,
				),
				'supports'           => array( 'title', 'page-attributes' ),
			);
			register_post_type('addify_gpby', $args);

				$labels = array(
					'name'                => __('Group Info', 'addify-group-buy-for-woocommerce'),
					'singular_name'       => __('Group Info', 'addify-group-buy-for-woocommerce'),
					'add_new'             => __('Add new', 'addify-group-buy-for-woocommerce'),
					'add_new_item'        => __('Add new', 'addify-group-buy-for-woocommerce'),
					'edit_item'           => __('Edit Rule', 'addify-group-buy-for-woocommerce'),
					'new_item'            => __('New Rule', 'addify-group-buy-for-woocommerce'),
					'view_item'           => __('View Rule', 'addify-group-buy-for-woocommerce'),
					'search_items'        => __('Search Rule', 'addify-group-buy-for-woocommerce'),
					'exclude_from_search' => true,
					'not_found'           => __('No rule found', 'addify-group-buy-for-woocommerce'),
					'not_found_in_trash'  => __('No rule found in trash', 'addify-group-buy-for-woocommerce'),
					'parent_item_colon'   => '',
					'all_items'           => __('Group Buying', 'addify-group-buy-for-woocommerce'),
					'menu_name'           => __('Group Buying', 'addify-group-buy-for-woocommerce'),
				);
		
				$args = array(
					'labels'             => $labels,
					'public'             => false,
					'publicly_queryable' => false,
					'show_ui'            => true,
					'show_in_menu'       => 'woocommerce',
					'query_var'          => true,
					'capability_type'    => 'post',
					'has_archive'        => true,
					'hierarchical'       => false,
					'menu_position'      => 80,
					'rewrite'            => array(
						'slug'       => 'addify_gpinfo',
						'with_front' => false,
					),
					'supports'           => array( 'title' ),
				);
			register_post_type('addify_gpinfo', $args);
		}

		public function adf_gpby_email_register( $emails ) {

		
			include_once AF_GPBY_DIR . 'includes/email/adf_gpby_join_email_register.php';
			$emails['Adf_Gpby_Join_Email_Register'] = new Adf_Gpby_Join_Email_Register();

			include_once AF_GPBY_DIR . 'includes/email/adf_gpby_qualified_group_email.php';
			$emails['Adf_Gpby_Qualified_Group_Email'] = new Adf_Gpby_Qualified_Group_Email();

			include_once AF_GPBY_DIR . 'includes/email/adf_gpby_disqualified_group_email.php';
			$emails['Adf_Gpby_Disqualified_Group_Email'] = new Adf_Gpby_Disqualified_Group_Email();

			include_once AF_GPBY_DIR . 'includes/email/adf_gpby_private_group_email.php';
			$emails['Adf_Gpby_Private_Group_Email'] = new Adf_Gpby_Private_Group_Email();

			return $emails;
		}

		public function adf_gpby_hide_buygroupid_meta_data( $formatted_meta, $item ) {
			foreach ( $formatted_meta as $key => $meta ) {
				if ( 'buyGroupId' === $meta->key ) {
					unset( $formatted_meta[ $key ] );
				}
			}
			return $formatted_meta;
		}
	}
	new Addify_Group_Buying_Main();
endif;
